<?php
/**
 * User: dmon
 */

interface Database {

    function connect();

    function disconnect();

    /* Execute database query. */
    function query($query);

    /* Determine total rows affected by query. */
    function affectedRows();

    /* Determine total rows returned by query */
    function numRows();

    /* Return query result row as an object. */
    function fetchObject();
    /* Return query result row as an indexed array. */
    function fetchRow();

    /* Return query result row as an associated array. */
    function fetchArray();

    /* Return total number of queries executed during
    lifetime of this object. Not required, but
    interesting nonetheless. */
    function numQueries();

    function numberFields();

    function fieldName($offset);

    function getResultAsTable();

    function pageLinks($totalpages, $currentpage, $pagesize, $parameter);

} 