<?php
/**
 * Created by PhpStorm.
 * User: dmon
 * Date: 4/30/14
 * Time: 9:51 AM
 *
 * Baut eine SQL Abfrage zusammen, die die connectlog_ids ermittelt
 */

namespace mailtraceApi;




class Parser {

    private $limit = 25;
    private $offset = 0;

    private $deliver_first = true;
    private $searchDeliverLog = false;

    private $format_date;

    private $date_from;
    private $date_to;
    private $mx_name;
    private $mail_from;
    private $mail_to;

    private $server = array();
    private $connects;

    public function getServerListSql(){
        return "SELECT id, s_name FROM servers";
    }

    public function setServerList($array){
        if(is_array($array[0])){
            foreach($array AS $key => $val){
                $this->server[$val['id']] = $val['s_name'];
            }
        }
    }

    public function getServer($id){
        return $this->server[$id];
    }

    public function getConnectLines(){
        if($this->searchDeliverLog){
            $sub_select = $this->searchDeliverLogs();
            $get_connectline_sql = "SELECT * FROM connectlog_$this->format_date WHERE dbid IN ($sub_select) ";
            if($this->mail_from != null || $this->mail_from != ''){
                $get_connectline_sql .= "AND c_mailfrom LIKE '" . $this->mail_from . "' ";
            }
            $get_connectline_sql .= "ORDER BY dbid LIMIT $this->limit OFFSET $this->offset";
        } else {
            $get_connectline_sql = $this->searchConnectLogs();
        }
        return $get_connectline_sql;
    }

    public function parseKeys($keys){
        // TODO: filter variables
        foreach ($keys AS $key => $value){
            switch($key){
                case 'hmt_query_token':
                    break;
                case 'v_date_from':
                    $this->date_from = $value;
                    break;
                case 'v_date_to':
                    $this->date_to = $value;
                    break;
                case 'c_mxname':
                    $this->mx_name = $value;
                    break;
                case 'c_mail_from':
                    $this->mail_from = $value;
                    break;
                case 'd_mail_to':
                    $this->mail_to = $value;
                    $this->searchDeliverLog = true;
                    break;
                default:
            }
        }
        $this->format_date = $this->parseDateToTableTimestamp($this->date_from);
    }

    public function addToSqlString($sql, $key, $value){
        if(is_numeric($value)){
            $comparer = '=';
        } else {
            $comparer = 'LIKE';
        }
        if(!$this->deliver_first){
            $sql .= "AND $key $comparer '$value' ";
        } else {
            $this->deliver_first = false;
            $sql .= " $key $comparer '$value' ";
        }
        return $sql;
    }

    public function searchDeliverLogs(){
        $sub_select_sql = "SELECT DISTINCT d_dbid FROM deliverlog_$this->format_date WHERE ";
        $sub_select_sql = $this->addToSqlString($sub_select_sql, 'd_mailto', $this->mail_to);
        if($this->mx_name != -1){
            $sub_select_sql = $this->addToSqlString($sub_select_sql, 'd_server', $this->mx_name);
        }
        $this->deliver_first = true;
        return $sub_select_sql;
    }

    public function searchConnectLogs(){
        return "SELECT * FROM connectlog_$this->format_date ORDER BY dbid LIMIT $this->limit OFFSET $this->offset";
    }

    public function filterConnectLines($pre_trails){
        foreach($pre_trails AS $trails_key => $trails){
            foreach($trails AS $trail){
                if($this->mail_from != '' && $trail['c_mailfrom'] != $this->mail_from){
                    unset($pre_trails[$trails_key]);
                } else if($this->mx_name != '-1' && $trail['c_server'] != $this->mx_name){
                    unset($pre_trails[$trails_key]);
                }
            }
        }
        return $pre_trails;
    }

    function getConnectedDeliveryLines($connect_line_ids){
        $connect_line_ids = implode(', ', $connect_line_ids);
        $select_sql = "SELECT * FROM deliverlog_$this->format_date WHERE d_dbid IN ($connect_line_ids) ORDER BY id ASC";
        return $select_sql;
    }

    public function parseDateToTableTimestamp($date){
        $format_date = preg_replace("/[^0-9]/", "", $date);
        return $format_date;
    }
} 