<?php
/**
 * Created by PhpStorm.
 * User: dmon
 * Date: 4/29/14
 * Time: 10:40 AM
 */
include_once 'classes/Parser.php';
// include_once 'classes/DB_MySQL.php';
include_once 'classes/DB_PostgresSQL.php';

function getInformation($trail){
    $meta = array();
    $meta['start_time'] = $trail[0]['c_time'];
    $meta['end_time'] = $trail[count($trail) - 1]['d_time'];
    $meta['from'] = $trail[0]['c_mailfrom'];
    $meta['msg_id'] = $trail[0]['c_messageid'];
    $meta['cid'] = $trail[0]['dbid'];
    return $meta;
}

function groupConnectLines($connects){
    $trails = array();
    foreach($connects AS $connect){
        $msid = $connect['c_messageid'];
        $trails[$msid][] = $connect;
    }
    return $trails;
}

function sortSteps($a, $b) {
    if(isset($a['c_utime'])){
        $a['time'] = $a['c_utime'];
    } else {
        $a['time'] = $a['d_utime'];
    }
    if(isset($b['c_utime'])){
        $b['time'] = $b['c_utime'];
    } else {
        $b['time'] = $b['d_utime'];
    }
    return (strcmp($a['time'], $b['time']));
}

// Parse Keys
$keys = array();
foreach($_GET AS $key => $get){
    if($get != ''){
        $keys[$key] = $get;
    }
}
$DB = new DB_PostgresSQL('localhost', 'mailtrace', 'mailtrace', 'mailtrace');
$DB->connect();

$parser = new mailtraceApi\Parser;

$server_sql = $parser->getServerListSql();
$result = $DB->query($server_sql); // alle server
$server = @pg_fetch_all($result);
$parser->setServerList($server);

$parser->parseKeys($keys);
$connect_line_sql = $parser->getConnectLines();
// Parsed Keys



$result = $DB->query($connect_line_sql); // alle connectlines
// echo 'Connect-lines: ' . $DB->numRows() . "<br />\n";
$num_connects = $DB->numRows();
$connects = @pg_fetch_all($result);
// var_dump($connects);


// TODO: Filtern der connectlines
$trails = array();
$pre_trails = groupConnectLines($connects);
$pre_trails = $parser->filterConnectLines($pre_trails);

// deliverlines nachladen
foreach($pre_trails AS $trail_key => $trail){
    $connect_line_ids = array();
    foreach($trail AS $step){
        $connect_line_ids[] = $step['dbid'];
    }
    $delivery_lines_sql = $parser->getConnectedDeliveryLines($connect_line_ids);
    $result = $DB->query($delivery_lines_sql);
    $delivery_lines = @pg_fetch_all($result);
    $trail = array_merge($trail, $delivery_lines);

    uasort($trail, 'sortSteps');
    $trail = array_values($trail);
    foreach($trail AS $t => $k){
        if(isset($k['c_server'])){
            $id = $k['c_server'];
            $server = $parser->getServer($id);
            $trail[$t]['c_server'] = $server;
        } elseif (isset($k['d_server'])){
            $id = $k['d_server'];
            $server = $parser->getServer($id);
            $trail[$t]['d_server'] = $server;
        }
    }
    $trails[] = $trail;
}

// sortieren und besondere werte aggregieren
$completed_trails = array();
$i = 0;

foreach($trails AS $trail){
    $completed_trails[$i]['lines'] = $trail;
    $completed_trails[$i]['meta'] = getInformation($trail);
    // echo var_export($completed_trails[$i], true) . '<br />' . '<br />';
    $i++;
}
echo json_encode($completed_trails);
