<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 23.08.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Controller/Config.php';
require_once 'Hpls/Settings.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Admin_MaintenanceController extends Hpls_Controller_Config {

	public function preDispatch() {
		if (!Hpls_Application::i()->isStandAlone()) {
			$this->_redirect('/overview');
		}
	}

	public function indexAction() {
		$localCfg = Hpls_Settings::i()->getConfig('ac.maintenance.local');
		$globalCfg = Hpls_Settings::i()->getConfig('ac.maintenance.global');
		$this->log()->debug(Hpls_Debug::print_r($this->getRequest()->getParams(), __METHOD__));
		if (is_null($localCfg)) {
			$localCfg = new Zend_Config(array(), true);
		}
		if (is_null($globalCfg)) {
			$globalCfg = new Zend_Config(array(), true);
		}
		if ($this->getRequest()->isPost()) {
			$localCfg->offline = Hpls_Utils::toBool($this->_getParam('ac_admin_maintenance_local_active', false));
			$localCfg->message = $this->_getParam('ac_admin_maintenance_local_message', '');
			$localCfg->text = $this->_getParam('ac_admin_maintenance_local_text', '');
			$globalCfg->offline = Hpls_Utils::toBool($this->_getParam('ac_admin_maintenance_global_active', false));
			$globalCfg->message = $this->_getParam('ac_admin_maintenance_global_message', '');
			$globalCfg->text = $this->_getParam('ac_admin_maintenance_global_text', '');
			try {
				Hpls_Settings::i()->setConfig('ac.maintenance.local', $localCfg, true);
				Hpls_Settings::i()->setConfig('ac.maintenance.global', $globalCfg, true);
				$this->_redirect('admin/maintenance'); //(de)aktiviert das Maintenance-Plugin
			} catch (Exception $ex) {
				
				Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, __CLASS__, 'Fehler beim Speichern der Einstellungen: ' . $ex->getMessage(), $ex->getCode());
			}
			$localCfg = Hpls_Settings::i()->getConfig('ac.maintenance.local', true);
			$globalCfg = Hpls_Settings::i()->getConfig('ac.maintenance.global', true);
			if (is_null($localCfg)) {
				$localCfg = new Zend_Config(array(), true);
			}
			if (is_null($globalCfg)) {
				$globalCfg = new Zend_Config(array(), true);
			}
		}
		$this->view->ac_admin_maintenance_local_active = Hpls_Utils::toBool(isset($localCfg->offline) ? $localCfg->offline : false);
		$this->view->ac_admin_maintenance_local_text = $localCfg->text;
		$this->view->ac_admin_maintenance_local_message = $localCfg->message;
		$this->view->ac_admin_maintenance_global_active = Hpls_Utils::toBool(isset($globalCfg->offline) ? $globalCfg->offline : false);
		$this->view->ac_admin_maintenance_global_text = $globalCfg->text;
		$this->view->ac_admin_maintenance_global_message = $globalCfg->message;
		
		$this->log()->debug(__METHOD__ . Hpls_Debug::print_r($localCfg, 'local') . (is_null($globalCfg) ? ' null ' : ' NOT NULL ') . Hpls_Debug::print_r($globalCfg, 'global'));
	}

	/* (non-PHPdoc)
	 * @see Hpls_Controller_Config::checkAction()
	 */
	public function checkAction() {
		// TODO Auto-generated method stub
	

	}

	public function isLocalOffline() {
		return Hpls_Utils::toBool(isset($this->cfg['maintenance']['local']['offline']) ? $this->cfg['maintenance']['local']['offline'] : false);
	}

	public function isGlobalOffline() {
		return Hpls_Utils::toBool(isset($this->cfg['maintenance']['global']['offline']) ? $this->cfg['maintenance']['global']['offline'] : false);
	}

	public function getLocalText() {
		return $this->cfg['maintenance']['local']['text'];
	}

	public function getGlobalText() {
		return $this->cfg['maintenance']['global']['text'];
	}
}