<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 05.09.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-12-06 11:09:08 +0100 (Do, 06 Dez 2012) $
 * last changed by: $LastChangedBy: d.mohn $
 * revision       : $LastChangedRevision: 9848 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.frontend/application/modules/config/controllers/WebuiController.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Controller/Config.php';
/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9848 $
 * @since 1.0.9
 */
class Config_WebuiController extends Hpls_Controller_Config {

	public function mtaAction() {
		$cfg = Hpls_Settings::i()->getConfig('ac.mail.smtp');
		if (is_null($cfg)) {
			$cfg = new Zend_Config(array(
					'host' => '',
					'port' => '',
					'type' => 'smtp',
					'auth_required' => false,
					'sender_address' => Hpls_Consts::HPLS_MAIL_ADRESS ));
		}
		if (!isset($cfg->auth)) {
			$cfg->auth = new Zend_Config(array(
					'username' => '',
					'password' => '',
					'method' => 'plain' ));
		} else {
			if (isset($cfg->auth->password)) {
				$cfg->auth->password = Hpls_Utils::getClearPassword($cfg->auth->password);
			}
		}
		
		if ($this->_request->isPost()) {
			$cfg->type = $this->_getParam('ac_mta_auth_type', 'smtp');
			switch ($cfg->type) {
				case 'smtp' :
					$cfg->host = $this->_getParam('ac_mta_srv_host', '');
					$cfg->port = $this->_getParam('ac_mta_srv_port', '');
					$cfg->auth_required = ('yes' == $this->_getParam('ac_mta_srv_auth_required', 'no')) ? true : false;
					break;
				case 'php' :
					$cfg->auth_required = false;
					$cfg->host = '';
					$cfg->port = '';
					break;
			}
			$cfg->sender_address = $this->_getParam('ac_mta_srv_sender_address', Hpls_Consts::HPLS_MAIL_ADRESS);
			if ($cfg->auth_required) {
				$cfg->auth->username = $this->_getParam('ac_mta_srv_username', '');
				$cfg->auth->password = Hpls_Utils::cryptPassword($this->_getParam('ac_mta_srv_password', ''));
				$cfg->auth->method = $this->_getParam('ac_mta_auth_method', 'plain');
			} else {
				//required == no -> alle anmeldeinfos löschen
				$cfg->auth = new Zend_Config(array(
						'username' => '',
						'password' => '',
						'method' => 'plain' ));
			}
			try {
				Hpls_Settings::i()->setConfig('ac.mail.smtp', $cfg)->save();
				$cfg = Hpls_Settings::i()->getConfig('ac.mail.smtp', true);
				if (isset($cfg->auth) && isset($cfg->auth->password)) {
					$cfg->auth->password = Hpls_Utils::getClearPassword($cfg->auth->password);
				}
			} catch (Exception $ex) {
				$this->log()->err($ex);
				Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'settings', 'Einstellungen konnten nicht gespeichert werden:\n' . $ex->getMessage(), $ex->getCode());
			}
		}
		
		$ac_mta = array(
				'type_options' => array(
						'php' => 'ac_mta_type_php_label',
						'smtp' => 'ac_mta_type_smtp_label' ),
				'auth_method_options' => array(
						'plain' => 'Plain',
						'crammd5' => 'CRAM MD5',
						'ssl' => 'SSL',
						'tls' => 'TLS' ),
				'type' => $cfg->type,
				'host' => $cfg->host,
				'port' => $cfg->port,
				'auth_required' => $cfg->auth_required ? 'yes' : 'no',
				'sender_address' => $cfg->sender_address,
				'username' => $cfg->auth->username,
				'password' => $cfg->auth->password,
				'authmethod' => $cfg->auth->method );
		$this->view->ac_mta = $ac_mta;
	}
	
	public function sourcesAction(){
		
		$cfg = Zend_Registry::get(Hpls_Consts0::REGK_AUTH)->toArray();
		$cfg['sourceMyImapOnly']['ssloptions'] = array('no' => 'Nein (Port 143)','tls' => 'TLS (Port 143)','yes' => 'SSL (Port 993)');
		$cfg['sourceMyImapOnly']['authoptions'] = array('digestmd5' => 'DIGESTMD5', 'crammd5' => 'CRAMMD5','plain' => 'PLAIN');
		$cfg['sourceMyLdap']['ssloptions'] = array('no' => 'Nein (Port 389)','tls' => 'TLS (Port 389)','yes' => 'SSL (Port 636)');
		$cfg['sourceMyLdap']['protocoloptions'] = array('2' => '2','3' => '3');
                
                $config = new Zend_Config_Xml(realpath(APPLICATION_PATH . "/..") . DIRECTORY_SEPARATOR . 'etc' . DIRECTORY_SEPARATOR . 'AC' . DIRECTORY_SEPARATOR . Hpls_Consts0::FILE_CONFIG_AUTH);
                $ini_path = realpath(APPLICATION_PATH . "/..") . DIRECTORY_SEPARATOR . 'etc' . DIRECTORY_SEPARATOR . 'AC' . DIRECTORY_SEPARATOR . $config->sourceMyIni->server->file;
                $ini_file = file_get_contents($ini_path);
                $cfg['sourceMyIni']['file'] = $ini_file;
                
		if ($this->_request->isPost()) {
			$source_string = 'sourceMyIni';
			if($this->_getParam('ac_sources_imap_only', '') == 1){
				$source_string .= ',sourceMyImapOnly';
			}
			if($this->_getParam('ac_sources_ldap', '') == 1){
				$source_string .= ',sourceMyLdap';
			}
			$cfg['auth']['source'] = $source_string;
			
			if($this->_getParam('ac_sources_imap_host', $cfg['sourceMyImapOnly']['server']['host']) != ''){
				$cfg['sourceMyImapOnly']['server']['host'] = $this->_getParam('ac_sources_imap_host', $cfg['sourceMyImapOnly']['server']['host']);
			}
			if($this->_getParam('ac_sources_imap_ssl') != ''){
				$cfg['sourceMyImapOnly']['server']['ssl'] = $this->_getParam('ac_sources_imap_ssl');
			}
			if($this->_getParam('ac_sources_imap_authmethod', $cfg['sourceMyImapOnly']['server']['authmethod']) != ''){
				$cfg['sourceMyImapOnly']['server']['authmethod'] = $this->_getParam('ac_sources_imap_authmethod', $cfg['sourceMyImapOnly']['server']['authmethod']);
			}
			if($this->_getParam('ac_sources_ldap_host', $cfg['sourceMyLdap']['server']['host']) != ''){
				$cfg['sourceMyLdap']['server']['host'] = $this->_getParam('ac_sources_ldap_host', $cfg['sourceMyLdap']['server']['host']);
			}
			if($this->_getParam('ac_sources_ldap_port', $cfg['sourceMyLdap']['server']['port']) != ''){
				$cfg['sourceMyLdap']['server']['port'] = $this->_getParam('ac_sources_ldap_port', $cfg['sourceMyLdap']['server']['port']);
			}
			if($this->_getParam('ac_sources_ldap_ssl', $cfg['sourceMyLdap']['server']['ssl']) != ''){
				$cfg['sourceMyLdap']['server']['ssl'] = $this->_getParam('ac_sources_ldap_ssl', $cfg['sourceMyLdap']['server']['ssl']);
			}
			if($this->_getParam('ac_sources_ldap_protocol', $cfg['sourceMyLdap']['server']['protocol']) != ''){
				$cfg['sourceMyLdap']['server']['protocol'] = $this->_getParam('ac_sources_ldap_protocol', $cfg['sourceMyLdap']['server']['protocol']);
			}
			if($this->_getParam('ac_sources_ldap_bind', $cfg['sourceMyLdap']['server']['bind']['dn']) != ''){
				$cfg['sourceMyLdap']['server']['bind']['dn'] = $this->_getParam('ac_sources_ldap_bind', $cfg['sourceMyLdap']['server']['bind']['dn']);
			}
			
			// write to xml file...
			try {
				$config = new Zend_Config_Writer_Xml();
				$config->write(realpath(APPLICATION_PATH . "/..") . DIRECTORY_SEPARATOR . 'etc' . DIRECTORY_SEPARATOR . 'AC' . DIRECTORY_SEPARATOR . Hpls_Consts0::FILE_CONFIG_AUTH, new Zend_Config($cfg));
				Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_INFO, 'ac_sources', "Config File '" . Hpls_Consts0::FILE_CONFIG_AUTH . "' gespeichert.");
			} catch (Exception $e) {
				Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'settings', 'Einstellungen konnten nicht gespeichert werden:\n' . $ex->getMessage(), $ex->getCode());
			}
			try {
				$ini = Hpls_Utils::readConfigXmlCascade(Hpls_Consts0::FILE_CONFIG_AUTH);
				Zend_Registry::set(Hpls_Consts0::REGK_AUTH, $ini);
			} catch (Exception $e) {
				Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'registry', 'Einstellungen konnten in der Registry gespeichert werden:\n' . $ex->getMessage(), $ex->getCode());
			}
                        try {
                                $cfg['sourceMyIni']['file'] = $this->_getParam('ac_sources_ini_file');
                                file_put_contents($ini_path, $this->_getParam('ac_sources_ini_file'));
                                Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_INFO, 'ac_sources', "Users.ini wurde gespeichert.");
                        } catch (Exception $e) {
                                Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'users', 'Users.ini konnte nicht gespeichert werden:\n' . $ex->getMessage(), $ex->getCode());
                        }
                        
		}
		$sources = $cfg['auth']['source'];
		if(preg_match('/sourceMyImapOnly/', $sources)){
			$cfg['sourceMyImapOnly']['on'] = true;
		}
		if(preg_match('/sourceMyLdap/', $sources)){
			$cfg['sourceMyLdap']['on'] = true;
		}
		// check for ldap and imap php support
		$cfg['sourceMyImapOnly']['allow'] = function_exists('imap_open');
		$cfg['sourceMyLdap']['allow'] = function_exists('ldap_bind');
		
		$this->view->ac_sources = $cfg;	
	}

	/* (non-PHPdoc)
	 * @see Hpls_Controller_Config::checkAction()
	 */
	public function checkAction() {
		// TODO Auto-generated method stub
	

	}

}