<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 01.08.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Mailtrace/Consts.php';
require_once 'Hpls/Mailtrace/Controller/Action.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class HmtReason_DbController extends Hpls_Mailtrace_Controller_Action {

	public function indexAction() {
	
	}

	public function importAction() {
	
	}

	public function exportAction() {
		require_once 'Hmt/Reason/Exporter.php';
		$run = true;
		
		if (FALSE === Hpls_Acl::i()->hasRole(Hpls_Acl::ROLE_HPLSADMIN)) {
			$this->forwardRequiredRole(Hpls_Acl::ROLE_HPLSADMIN);
			return;	
		}
		
		$exportCfg = Hpls_Settings::i()->getConfig('hmt.reason.export');
		// TODO: später ein löschen über GUI
		//		if (FALSE !== empty($this->getRequest()->getParam('drop'))) {
		

		//$file = $this->getRequest()->getParam('drop');
		//unlink($exportCfg->dir . '/' . $)
		//Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_INFO, 'hmt_reason_export', "Exportdatei '$file' gelöscht.");
		//return;
		//		}
		

		if (NULL !== $this->getRequest()->getParam('download')) {
			$file = $this->getRequest()->getParam('download');
			$filepath = $exportCfg->dir . DIRECTORY_SEPARATOR . $file;
			if (file_exists($filepath)) {
				header("Pragma: public");
				header("Expires: 0");
				header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
				header("Cache-Control: public");
				header("Content-Description: File Transfer");
				header("Content-type: application/octet-stream");
				header("Content-Disposition: attachment; filename=\"" . $file . "\"");
				header("Content-Transfer-Encoding: binary");
				header("Content-Length: " . filesize($filepath));
				ob_end_flush();
				@readfile($filepath);
				$run = false;
			}
		}
		
		if ((is_null($exportCfg) || !isset($exportCfg->dir)) && $run) {
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export', "Exportverzeichnis wurde nicht konfiguriert.");
			return;
		}
		
		if ($this->getRequest()->isPost() && $run) {
			
			if (is_null($exportCfg)) {
				$exportCfg = new Zend_Config(array(
						'dir' => '/tmp' ));
			}
			
			// Formulardaten werden übergeben.
			$exportDir = $this->getRequest()->getParam('hmtr_exportdir');
			if ($exportCfg->div != $exportDir) {
				$exportCfg->dir = $exportDir;
				
				if (empty($exportCfg->dir)) {
					Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export', "Exportverzeichnis darf nicht leer sein");
					return;
				} elseif (FALSE === is_dir($exportCfg->dir) || FALSE === is_writable($exportCfg->dir)) {
					// Existiert nicht | nicht beschreibbar
					if (FALSE === is_dir($exportCfg->dir)) {
						Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export', "Exportverzeichnis ist nicht vorhanden. (" . $exportCfg->dir . ")");
						return;
					} elseif (FALSE === is_writable($exportCfg->dir)) {
						Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export', "Exportverzeichnis ist nicht beschreibbar. (" . $exportCfg->dir . ")");
						return;
					}
				} else {
					// alles stimmt		
					try {
						Hpls_Settings::i()->setConfig('hmt.reason.export', $exportCfg, true);
					} catch (Exception $ex) {
						Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export', "Exportverzeichnis wurde nicht konfiguriert." . $ex->getMessage());
						return;
					}
				}
			}
			
			// Export der Daten
			$exportLang = $this->getRequest()->getParam('hmtr_lang');
			$exportDb = Hpls_Mailtrace_Consts::CONFIG_KEY_VENDORDB;
			// TODO: Falsche Export werte:
			$options = array(
					'langs' => array(
							$exportLang ),
					'database' => $exportDb,
					Hmt_Reason_Exporter::OPTION_KEY_CONFIG => Hpls_Settings::i()->getConfig('hmt.reason.export') );
			
			ob_start();
			
			$exporter = Hmt_Reason_Exporter::i();
			$exporter->setOptions($options);
			
			$exporter->run();
			
			// Abschluss (Achivierung + TempDir löschen)
			Hmt_Reason_Exporter::createArchive($options[Hmt_Reason_Exporter::OPTION_KEY_CONFIG], $exporter->getTempDir(), $exporter->getFiles());
			Hmt_Reason_Exporter::deleteTempDir($exporter->getTempDir(), $options[Hmt_Reason_Exporter::OPTION_KEY_CONFIG]->filetype);
			
			if ($exporter->hasProcessSuccess()) {
				Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_INFO, 'hmt_reason_export', "Export erfolgreich erstellt.");
			}
			
			$debug = ob_get_contents();
			ob_end_clean();
			$this->view->export_debug = "<pre>" . $debug . "</pre>";
		}
		
		// Liste der Exports
		$exports = scandir($exportCfg->dir, 1);
		$exportList = array();
		foreach ($exports as $file) {
			if ($file !== '.' && $file !== '..') {
				$tmp = explode("_", $file);
				$date = date("d.m.Y H:i:s", $tmp[1]);
				$link = $this->getFrontController()->getBaseUrl() . sprintf($exportCfg->link, $file);
				
				$exportList[] = array(
						'name' => $file,
						'link' => $link,
						'date' => $date );
			}
		}
		
		$this->view->exportList = $exportList;
		
		$this->view->exportDir = $exportCfg->dir;
	}

	public function updateAction() {
		require_once 'Hmt/Reason/Updater.php';
		
		if (FALSE === class_exists('ZipArchive')) {
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_update_import', "Fehlende PHP Erweiterung: Zip");
			return;
		}
		// vorläufig, weil der UpdateServer noch nicht funktioniert:
		$this->view->showUpdateDownload = Hpls_Application0::i()->isStandAlone();
		
		if ($this->getRequest()->isPost()) {
			
			$updateCfg = Hpls_Settings::i()->getConfig('hmt.reason.update');
			$dbCfg = Hpls_Settings::i()->getConfig('hmt.reason.storage.vendor');
			
			if (is_null($updateCfg) || is_null($dbCfg)) {
				Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_update_import', "Konfiguration nicht geladen.");
				return;
			}
			
			$extractMethod = $updateCfg->extractmethod; // TODO: vom Formular
			

			$updateDb = Hpls_Mailtrace_Consts::CONFIG_KEY_VENDORDB;
			// TODO: Falsche Export werte:
			$options = array(
					'extractmethod' => $extractMethod,
					'database' => $updateDb,
					'type' => $dbCfg->type,
					'file' => null,
					Hmt_Reason_Updater::OPTION_KEY_CONFIG => $updateCfg );
			
			ob_start();
			
			$btnUpdate = $this->getRequest()->getParam('hmtr_update', NULL);
			$btnImport = $this->getRequest()->getParam('hmtr_import', NULL);
			$db = Hmt_Reason_Edit::i()->getDbO($updateDb);
			
			$cid = 1;
			$pid = "mailtrace_reasondb";
			$pversion = $db->getVersion();
			$prefix = "hmtr_";
			$hmtr1 = $db->getConfigValue('version');
			;
			$hmtr2 = $db->getVersion();
			
			if ($btnUpdate != NULL) {
				$params = array(
						'cid=' . md5($cid),
						'pid=' . urlencode(base64_encode($pid)),
						'pversion=' . urlencode(base64_encode($pversion)),
						'prefix=' . urlencode(base64_encode($prefix)),
						'hmtr_db_structure_version=' . urlencode(base64_encode($hmtr1)),
						'hmtr_db_entry_version=' . urlencode(base64_encode($hmtr2)) );
				$url .= $updateCfg->url . '?' . implode('&', $params);
				echo $url;
				$options['file'] = $this->getDataFromUpdateServer($url, $updateCfg->dir);
				if (FALSE === $options['file']) {
					return;
				}
			} else if ($btnImport !== NULL) {
				try {
					require_once 'Zend/File/Transfer/Adapter/Http.php';
					$fileAdapter = new Zend_File_Transfer_Adapter_Http();
					$fileAdapter->setDestination($updateCfg->dir);
					if (!($options['file'] = $fileAdapter->receive())) {
						$messages = $fileAdapter->getMessages();
						if (array_key_exists('fileUploadErrorNoFile', $messages)) {
							$msg = "Bitte eine Datei auswählen.";
						}
						throw new Exception($msg);
						return;
					}
					$options['file'] = $fileAdapter->getFileName();
				} catch (Exception $e) {
					Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_update_import', 'Upload fehlgeschlagen.\n' . $e->getMessage());
					return;
				}
			}
			
			$updater = Hmt_Reason_Updater::i();
			$updater->setOptions($options);
			$updater->run();
			
			if ($updater->hasProcessSuccess()) {
				Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_INFO, 'hmt_reason_export', "Update erfolgreich. Aktuelle Datenbank-Version: <strong>" . $updater->getVersion() . "</strong>");
			}
			
			$debug = ob_get_contents();
			ob_end_clean();
			$this->view->hmtr_debug = "<pre>" . $debug . "</pre>";			
		}
	
	}

	public function exportsettingsAction() {
		// DEPRECATED
	}

	protected function getDataFromUpdateServer($url, $destination) {
		$downloadUrl = '';
		
		$content = "";
		$handle_source = fopen($url, 'r');
		while (!feof($handle_source)) {
			$content .= fgets($handle_source, 4096);
		}
		list($downloadUrl, $fSize) = explode("\n", trim($content));
		
		return $this->downloadUpdate($downloadUrl, $destination);
	}

	/**
	 * Herunterladen der Update-File (evtl. Auslagerung in eine eigenständige Klasse)
	 */
	protected function downloadUpdate($url, $destination) {
		$arrUrl = explode('/', $url);
		$arrUrlR = array_reverse($arrUrl);
		$file = $arrUrlR[0];
		$destination .= DIRECTORY_SEPARATOR . $file;
		
		$handle_source = fopen($url, 'r');
		if (FALSE === $handle_source) {
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export', "System konnte die Update-Datei $url nicht öffnen.");
			return false;
		}
		
		$handle_target = fopen($destination, 'w');
		if (FALSE === $handle_target) {
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export', "System konnte Update-Datei $url nicht lokal als $destination speichern.");
			return false;
		}
		
		while (!feof($handle_source)) {
			$buffer = fgets($handle_source, 4096);
			$result = fwrite($handle_target, $buffer);
		}
		
		return $destination;
	}
}