<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Feb 27, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.frontend/application/modules/mailtrace/controllers/DetailsController.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 */
/***/
require_once 'Hpls/Mailtrace/Consts.php';
require_once 'Hpls/Mailtrace/Controller/Action.php';
require_once 'Hmt/Log.php';
require_once 'Hmt/Db/Query/Delivers.php';
require_once 'Hmt/Db/Query/Connects.php';
/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package HPLS
 * @subpackage subpackage
 * @version $LastChangedRevision: 9196 $
 * @since 1.0.9
 *
 * tags
 */
class Mailtrace_DetailsController extends Hpls_Mailtrace_Controller_Action {

	/**
	 * The default action - show the home page
	 */
	public function indexAction() { // TODO Auto-generated DetailsController::indexAction() default action
	}

	public function showAction() {
		$searchArray = array();
		$did = null;
		$cid = null;
		$part = null;
		if ($this->getRequest()->has('cid')) {
			$cid = $this->getRequest()->getParam('cid');
			$split = explode('c', $this->getRequest()->getParam('cid'));
			if (count($split) == 1) {
				$cid = $split[0];
			} elseif (count($split) == 2) {
				$cid = $split[1];
				$part = $split[0];
			}
		}
		if ($this->getRequest()->has('did')) {
			$split = explode('d', $this->getRequest()->getParam('did'));
			if (count($split) == 1) {
				$did = $split[0];
			} elseif (count($split) == 2) {
				$did = $split[1];
				if (!is_null($part) && $part != $split[0]) {
					require_once 'Hpls/Mailtrace/Exception/Usage.php';
					throw new Hpls_Mailtrace_Exception_Usage("Requested deliver entry is not in the same table (" . $split[0] . ") as the requested connect entry ($part).", 1);
				} else {
					$part = $split[0];
				}
			}
		
		}
		
		if ($this->getRequest()->has('rpart')) {
			if (!is_null($part) && $part != $this->getRequest()->getParam('rpart')) {
				require_once 'Hpls/Mailtrace/Exception/Usage.php';
				throw new Hpls_Mailtrace_Exception_Usage("Requested deliver entry is not in the same table (" . $split[0] . ") as the requested connect entry ($part).", 1);
			
			} else {
				$part = $this->getRequest()->getParam('rpart');
			}
		}
		
		//no/incorrect params given?
		if (is_null($cid) || is_null($part)) {
			$this->log()->err('No cid or part given.');
			$this->_redirect("/");
			return;
		}
		
		//@todo werte aus dem connectentry holen
		$clause = new Hpls_Var_Clause();
		$clause->addValue(Hpls_Mailtrace_Consts::SRCH_C_ID, $cid);
		$qry = new Hmt_Db_Query_Connects($clause);
		$qry->setPartition($part);
		Hmt_Log::i()->connect($qry);
		$qry->execute();
		$result = $qry->getResults();
		if (count($result) == 0) {
			$this->_forward('error');
			return;
		}
		
		$connect = reset($result);
		isDebug() && $this->getLogger()->debug(Hpls_Debug::print_r($connect, "connect entry: "));
		
		$this->view->connect = $connect;
		
		//delivers
		$clause = new Hpls_Var_Clause();
		$clause->addValue(Hpls_Mailtrace_Consts::SRCH_D_DBID, $cid);
		
		$qry = new Hmt_Db_Query_Delivers($clause);
		$qry->setPartition($part);
		Hmt_Log::i()->connect($qry);
		$qry->execute();
		$result = $qry->getResults();
		if (count($result) == 0) {
			$this->_forward('error');
			return;
		}
		
		//		$delivers = reset($result);
		isDebug() && $this->getLogger()->debug(Hpls_Debug::print_r($result, "deliver entries: "));
		
		$this->view->delivers = $result;
	
	}
}

