<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 22.02.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Controller/Action.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Resource_I18nController extends Hpls_Controller_Action {
	
	/**
	 * Wird gelesen von: $this->_helper->contextSwitch()->initContext()
	 * @var array:string:array
	 */
	public $contexts = array(
			'locale' => array(
					'js',
					'xml',
					'json' ) );

	public function __call($methodName, $args) {
		return parent::__call($methodName, $args);
	}

	public function init() {
		$this->_helper->contextSwitch()->addContext('js', array(
				'suffix' => 'js',
				'headers' => array(
						'Content-Type' => 'text/javascript' ) ));
		$this->_helper->contextSwitch()->setAutoDisableLayout(true);
		$this->view->addScriptPath(APPLIANCE_PART_PATH . "/templates/unthemed");
	}

	public function preDispatch() {
		$this->_helper->contextSwitch()->initContext();
	
		//		Zend_Layout::getMvcInstance()->disableLayout();
	}

	public function localeAction() {
		require_once 'Hpls/I18n/Utils.php';
		$this->getRequest()->setParam('format', $this->getRequest()->getParam('format', 'js'));
		$this->_helper->contextSwitch()->initContext();
		$this->view->locales_array = Hpls_I18n_Utils::getMessages();
		$this->view->locale = Zend_Registry::get(Hpls_Consts::REGK_LOCALE);
	}
}