--
-- Copyright (c) Heinlein Professional Linux Support GmbH
--
-- created   : 22.02.2012
-- created by: Christoph Graupner <c.graupner@heinlein-support.de>
--
-- last changed   : $LastChangedDate: 2012-02-23 17:02:15 +0100 (Do, 23. Feb 2012) $
-- last changed by: $LastChangedBy: cgr $
-- revision       : $LastChangedRevision: 9243 $
-- 
-- author         : Christoph Graupner <c.graupner@heinlein-support.de>
--

--
-- Trigger `config`
--
-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
DROP TRIGGER IF EXISTS `[[TABLEPREFIX]]config_on_insert`;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

DELIMITER //

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TRIGGER `[[TABLEPREFIX]]config_on_insert` BEFORE INSERT ON `[[TABLEPREFIX]]config`
 FOR EACH ROW BEGIN
 	IF (@DISABLE_TRIGGERS IS NULL) then
   SET NEW.time_updated = CURRENT_TIMESTAMP;
  END IF;
END;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

//
DELIMITER ;


-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
DROP TRIGGER IF EXISTS `[[TABLEPREFIX]]config_on_update`;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

DELIMITER //

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TRIGGER `[[TABLEPREFIX]]config_on_update` BEFORE UPDATE ON `[[TABLEPREFIX]]config`
 FOR EACH ROW BEGIN
 	IF (@DISABLE_TRIGGERS IS NULL) then
   SET NEW.time_updated = CURRENT_TIMESTAMP;
  END IF;
END;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

//
DELIMITER ;


--
-- Trigger `regexrule`
--
-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
DROP TRIGGER IF EXISTS `[[TABLEPREFIX]]regexrule_on_insert`;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

DELIMITER //

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TRIGGER `[[TABLEPREFIX]]regexrule_on_insert` BEFORE INSERT ON `[[TABLEPREFIX]]regexrule`
 FOR EACH ROW BEGIN
 	IF (@DISABLE_TRIGGERS IS NULL) then
   SET NEW.time_updated = CURRENT_TIMESTAMP;
  END IF;
END;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

//
DELIMITER ;

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
DROP TRIGGER IF EXISTS `[[TABLEPREFIX]]regexrule_on_update`;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

DELIMITER //

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TRIGGER `[[TABLEPREFIX]]regexrule_on_update` BEFORE UPDATE ON `[[TABLEPREFIX]]regexrule`
 FOR EACH ROW BEGIN
 	IF (@DISABLE_TRIGGERS IS NULL) then
   SET NEW.time_updated = CURRENT_TIMESTAMP;
  END IF;
END;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

//
DELIMITER ;


--
-- Trigger `roles`
--
-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
DROP TRIGGER IF EXISTS `[[TABLEPREFIX]]roles_on_insert`;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

DELIMITER //

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TRIGGER `[[TABLEPREFIX]]roles_on_insert` BEFORE INSERT ON `[[TABLEPREFIX]]roles`
 FOR EACH ROW BEGIN
 	IF (@DISABLE_TRIGGERS IS NULL) then
   SET NEW.time_updated = CURRENT_TIMESTAMP;
  END IF;
END;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

//
DELIMITER ;

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
DROP TRIGGER IF EXISTS `[[TABLEPREFIX]]roles_on_update`;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

DELIMITER //

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TRIGGER `[[TABLEPREFIX]]roles_on_update` BEFORE UPDATE ON `[[TABLEPREFIX]]roles`
 FOR EACH ROW BEGIN
 	IF (@DISABLE_TRIGGERS IS NULL) then
   SET NEW.time_updated = CURRENT_TIMESTAMP;
  END IF;
END;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

//
DELIMITER ;


--
-- Trigger `rule_ids`
--

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
DROP TRIGGER IF EXISTS `[[TABLEPREFIX]]rule_ids_on_insert`;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

DELIMITER //

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TRIGGER `[[TABLEPREFIX]]rule_ids_on_insert` BEFORE INSERT ON `[[TABLEPREFIX]]rule_ids`
 FOR EACH ROW BEGIN
 	IF (@DISABLE_TRIGGERS IS NULL) then
   SET NEW.time_updated = CURRENT_TIMESTAMP;
  END IF;
END;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

//
DELIMITER ;

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
DROP TRIGGER IF EXISTS `[[TABLEPREFIX]]rule_ids_on_update`;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

DELIMITER //

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TRIGGER `[[TABLEPREFIX]]rule_ids_on_update` BEFORE UPDATE ON `[[TABLEPREFIX]]rule_ids`
 FOR EACH ROW BEGIN
 	IF (@DISABLE_TRIGGERS IS NULL) then
   SET NEW.time_updated = CURRENT_TIMESTAMP;
  END IF;
END;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

//
DELIMITER ;
