
--
-- TOC entry 1755 (class 2604 OID 54100)
-- Dependencies: 1484 1483 1484
-- Name: id; Type: DEFAULT; Schema: public; Owner: mailtrace
--

ALTER TABLE regexrule ALTER COLUMN id SET DEFAULT nextval('regexrule_id_seq'::regclass);


--
-- TOC entry 1753 (class 2604 OID 54077)
-- Dependencies: 1480 1479 1480
-- Name: id; Type: DEFAULT; Schema: public; Owner: mailtrace
--

ALTER TABLE roles ALTER COLUMN id SET DEFAULT nextval('roles_id_seq'::regclass);


--
-- TOC entry 1754 (class 2604 OID 54087)
-- Dependencies: 1482 1481 1482
-- Name: id; Type: DEFAULT; Schema: public; Owner: mailtrace
--

ALTER TABLE rule_ids ALTER COLUMN id SET DEFAULT nextval('rule_ids_id_seq'::regclass);


--
-- TOC entry 1759 (class 2606 OID 54071)
-- Dependencies: 1478 1478
-- Name: pri_config_key; Type: CONSTRAINT; Schema: public; Owner: mailtrace; Tablespace: 
--

ALTER TABLE ONLY config
    ADD CONSTRAINT pri_config_key PRIMARY KEY ("key");


--
-- TOC entry 1769 (class 2606 OID 54106)
-- Dependencies: 1484 1484
-- Name: pri_id; Type: CONSTRAINT; Schema: public; Owner: mailtrace; Tablespace: 
--

ALTER TABLE ONLY regexrule
    ADD CONSTRAINT pri_id_t_regexrule PRIMARY KEY (id,id_t);


--
-- TOC entry 1765 (class 2606 OID 54092)
-- Dependencies: 1482 1482
-- Name: pri_id_rules; Type: CONSTRAINT; Schema: public; Owner: mailtrace; Tablespace: 
--

ALTER TABLE ONLY rule_ids
    ADD CONSTRAINT pri_id_t_rules PRIMARY KEY (id,id_t);


--
-- TOC entry 1761 (class 2606 OID 54079)
-- Dependencies: 1480 1480-- Name: pri_id_rules; Type: CONSTRAINT; Schema: public; Owner: mailtrace; Tablespace: 
--

ALTER TABLE ONLY rule_ids
    ADD CONSTRAINT pri_id_t_rules PRIMARY KEY (id,id_t);


--
-- TOC entry 1761 (class 2606 OID 54079)
-- Dependencies: 1480 1480
-- Name: pri_roles_id; Type: CONSTRAINT; Schema: public; Owner: mailtrace; Tablespace: 
--

ALTER TABLE ONLY roles
    ADD CONSTRAINT pri_id_t_roles PRIMARY KEY (id,id_t);



--
-- TOC entry 1771 (class 2606 OID 54108)
-- Dependencies: 1484 1484 1484
-- Name: unique_regex; Type: CONSTRAINT; Schema: public; Owner: mailtrace; Tablespace: 
--

ALTER TABLE ONLY regexrule
    ADD CONSTRAINT unique_regex UNIQUE (regex, deactivated);


--
-- TOC entry 1763 (class 2606 OID 54081)
-- Dependencies: 1480 1480
-- Name: unique_role_name; Type: CONSTRAINT; Schema: public; Owner: mailtrace; Tablespace: 
--

ALTER TABLE ONLY roles
    ADD CONSTRAINT unique_role_name UNIQUE (role_name);


--
-- TOC entry 1767 (class 2606 OID 54094)
-- Dependencies: 1482 1482
-- Name: unique_rule_id; Type: CONSTRAINT; Schema: public; Owner: mailtrace; Tablespace: 
--

ALTER TABLE ONLY rule_ids
    ADD CONSTRAINT unique_rule_id UNIQUE (rule_name);



--
-- TOC entry 1776 (class 2606 OID 54109)
-- Dependencies: 1484 1764 1482
-- Name: ref_regex_ruleid; Type: FK CONSTRAINT; Schema: public; Owner: mailtrace
--

ALTER TABLE ONLY regexrule
    ADD CONSTRAINT ref_regex_ruleid FOREIGN KEY (rule_id) REFERENCES rule_ids(id,id_t) ON DELETE SET NULL;

    
CREATE OR REPLACE FUNCTION set_update_time()
  RETURNS trigger AS
$BODY$
    BEGIN
        -- Remember who changed the payroll when
        NEW.time_updated := current_timestamp;
        RETURN NEW;
    END;
$BODY$
  LANGUAGE plpgsql VOLATILE
  COST 100;
    
CREATE TRIGGER update_stamp_rule_ids BEFORE INSERT OR UPDATE ON rule_ids
    FOR EACH ROW EXECUTE PROCEDURE set_update_time();
CREATE TRIGGER update_stamp_roles
  BEFORE INSERT OR UPDATE
  ON roles
  FOR EACH ROW
  EXECUTE PROCEDURE set_update_time();
CREATE TRIGGER update_stamp_regexrule BEFORE INSERT OR UPDATE ON regexrule
    FOR EACH ROW EXECUTE PROCEDURE set_update_time();
CREATE TRIGGER update_stamp_config BEFORE INSERT OR UPDATE ON config
    FOR EACH ROW EXECUTE PROCEDURE set_update_time();