<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 08.04.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hmt/Reason/RegEx.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hmt_Reason_Edit_RegEx extends Hmt_Reason_RegEx {

	public function setFromtable($value) {
		$this->fromtable = $value;
	}

	public function setID($value) {
		$id = explode(self::ID_SEP, $value);
		if (count($id) != 2) {
			throw new InvalidArgumentException("'$value' not in a format of '<id-seq-nr>-<id_t>'", -1);
		}
		$this->setIdS($id[0]);
		$this->setIdT($id[1]);
	}

	public function setIdS($value) {
		$this->id = intval($value);
	}

	public function setIdT($value) {
		$this->id_t = $value;
	}

	public function setRegEx($value) {
		$this->regex = $value;
	}

	public function setRuleId($value) {
		$id = explode(self::ID_SEP, $value);
		if (count($id) != 2) {
			throw new InvalidArgumentException("'$value' not in a format of '<id-seq-nr>-<id_t>'", -1);
		}
		$this->setRuleIdS($id[0]);
		$this->setRuleIdT($id[1]);
	}

	public function setRuleIdS($value) {
		$this->rule_id = $value;
	}

	public function setRuleIdT($value) {
		$this->rule_id_t = $value;
	}

	public function setDeactivated($value = true) {
		$this->inactive_state = $value ? 1 : 0;
	}

	public function setDescription($value) {
		$this->description = $value;
	}

	public function setPriority($value) {
		$this->priority = $value;
	}

	/**
	 * @todo comment
	 * @param array|string $map
	 * @throws Hpls_Exception_Unify
	 */
	public function setParamMap($map) {
		if (empty($map)) {
			$this->setParamMapDanger(null);
		}
		if (is_array($map)) {
			$this->setParamMapArray($map);
		} else {
			//ist ',' nicht das trennzeichen? -> probier's mit leerzeichen
			if (strpos($map, ',') === false) {
				$map = preg_split('/\s+/', $map);
			} else {
				$map = preg_split('/\s*\\,\s*/', $map);
			}
			var_dump($map);
			//ab hier array von einzelnen parameternamen
			$ret = array();
			$c = 0;
			foreach ($map as $pos => $name) {
				$name = trim($name);
				$s = preg_split('/\s*=\s*/', $name);
				if (count($s) > 1) {
					$intval = intval($s[0]);
					if ($intval > 0) {
						if (isset($ret[$intval])) {
							$z = array_slice($ret, null, $intval, true);
							$z2 = array_slice($ret, $intval, null, true);
							$z[] = $this->stripquotes($s[1]);
							$ret = array_merge($z, $z2);
						} else {
							$ret[$intval] = $this->stripquotes($s[1]);
						}
						ksort($ret);
					} else {
						require_once 'Hpls/Exception/Unify.php';
						throw new Hpls_Exception_Unify("'$name' is not a valid value for a reason parammap", Hpls_Consts::ERR_INVALID_VALUE, null, array(
								'map' => $map,
								'current' => $name ));
					}
				} else {
					//nächste freie position berechnen
					while (isset($ret[$pos + $c])) {
						$c++;
					}
					$ret[$pos + $c] = $this->stripquotes($name);
				}
			}
		}
		$this->setParamMapArray($ret);
	}

	public function setParamMapArray(array $map) {
		$str = '';
		$map = array_merge($map); //normalisieren der numerischen Indexe, dass sie mit 0 beginnen
		foreach ($map as $pos => $name) {
			$name = strtoupper($name);
			$name = preg_replace('/^\s*[\' "]*/', '', $name);
			$name = preg_replace('/[\' "]*\s*$/', '', $name);
			$str .= ($pos + 1) . '="' . $name . '";';
		}
		$this->setParamMapDanger($str);
	}

	function stripquotes($val) {
		$matches = array();
		if (preg_match('/^\s*"(.*)"\s*$/', $val, $matches) > 0) {
			return $matches[1];
		}
		return $val;
	
	}

	/**
	 * Bereitet die ParameterMap für die Darstellung im Formular auf
	 * @return string
	 */
	public function getParamMapDisplay() {
		$ret = parent::getParamMap();
		$ret = preg_replace('/;/', ', ', $ret);
		$ret = preg_replace('/"/', '', $ret);
		$ret = preg_replace('/,\s*$/', '', $ret);
		//		$ret = preg_replace('/\d+\s*=\s*/', '', $ret);
		return $ret;
	}

	/**
	 * @todo comment
	 * @param unknown_type $map
	 */
	public function setParamMapDanger($map) {
		$this->param_map = $map;
	}
}