<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 09.11.2011
 * created by     : Sebastian Nitzsche <s.nitzsche@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 *
 * author         : Sebastian Nitzsche <s.nitzsche@heinlein-support.de>
 */
/***/
require_once 'Hmt/Reason/Exporter.php';

class Hmt_Reason_Exporter_Mysql extends Hmt_Reason_Exporter {
	
	const TEMPLATE_NAME = 'mysql';
	protected static $_instance;

	/**
	 * @return Hmt_Reason_Exporter_Mysql
	 */
	public static function i() {
		if (is_null(self::$_instance)) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	/**
	 * Lädt die Template-Dateien aus dem Pfad, der in der components.ini (export.templatepath) angegeben ist.
	 * 
	 * @return void
	 */
	protected function loadTemplates() {
		$this->_sqlkey = self::TEMPLATE_NAME;
		$frontendPath = realpath(APPLICATION_PATH . '/..');
		$tplPath = $frontendPath . $this->_options['conf']->templatepath;
		$tplPathCommon = $frontendPath . $this->_options['conf']->templatepath;
		
		if (is_dir($tplPath) && is_dir($tplPathCommon)) {
			$this->_templates[self::TEMPLATE_NAME]['create'] = file_get_contents($tplPathCommon . '/create.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['create_table.reasons'] = file_get_contents($tplPathCommon . '/create_table.reasons.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['alter'] = "";
			$this->_templates[self::TEMPLATE_NAME]['truncate_table'] = file_get_contents($tplPath . '/truncate_table.mysql.tpl.sql');
			;
			$this->_templates[self::TEMPLATE_NAME]['insert.roles'] = file_get_contents($tplPath . '/insert.roles.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.config'] = file_get_contents($tplPath . '/insert.config.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.rules'] = file_get_contents($tplPath . '/insert.rules.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.reasons'] = file_get_contents($tplPath . '/insert.reasons.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.regex'] = file_get_contents($tplPath . '/insert.regex.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['config'] = file_get_contents($tplPath . '/controller.ini');
		} else {
			$this->log()->err("SQL Template Verzeichnis wurde nicht gefunden. ('$tplPath' oder '$tplPathCommon')");
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export_mysql', "SQL Template Verzeichnis wurde nicht gefunden. ('$tplPath' oder '$tplPathCommon')");
		}
		$this->getDbMysql();
	}

	protected function getDbMysql() {
		
		try {
			$config = Hpls_Settings::i()->getConfig('hmt.reason.export.db.mysql');
			$dbConfig = is_null($config) ? null : $config->toArray();
			
			$this->_dbAdapter = Hpls_Utils_Db::mapDriverType2ZendDb($dbConfig);
		} catch (Exception $ex) {
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_WARN, 'hmt_reason_export_mysql', "Keine Verbindung zu MySQL möglich. " . $ex->getMessage());
		}
	}
}