/**
 * 
 */
function ReasonResultController(config) {
	this._config = config;
	this.intervals = null;
	this.resultsMeta = {
	  limit : this._config.limit,
	  offset : 0,
	  query : null,
	  queryId : null,
	  newest : new Date(),
	  oldest : new Date(),
	  reftime : new Date(),
	  qar_counter : -1, // -1 --> um '0' für die erste Abfrage durch getNextQAR()
	  // zu erhalten
	  requestStats : {},
	  connectRes : {},
	  deliverRequest : {},
	  queue : {}, // abarbeitungsqueue für vom Server erhaltene Ergebnisse,
	  // aber
	  // noch nicht angezeigte
	  data : {}
	// angezeigte datenobjekte
	};
}

ReasonResultController.prototype.init = function() {
	this.resultsMeta.query = this.getRequestUrl();

	$.get(baseUrl + '/' + this._config.searchControllerZF + "/getintervals?format=json", function(
	    ergebnis) {
		if (ergebnis) {
			resCtrl.intervals = ergebnis.intervals;
		}
	});

	$('.hmt_searchtool_section').each(function(i, elem) {
		var iv = $(elem).attr('id');
		iv = iv.replace('iv', '');
		$('a.hmt_searchtool_link', elem).click(function() {
			resCtrl.requestResults(null, 0, null, {
				'rpart' : iv
			});
		}).attr('href', 'javascript: void(0);' + resCtrl.getLinkRequestUrl({
		  'rpart' : iv,
		  'roffset' : 0
		}));
	});
};
ReasonResultController.prototype.getRequestUrl = function() {
	return $('#' + this._config.searchFormID).serialize(); //
};

/**
 * v.utime v.rdir v.rjump v.rlimit v.roffset v.rpart
 * 
 * @param values
 */
ReasonResultController.prototype.getLinkRequestUrl = function(values) {
	var ret = this.resultsMeta.query;
	for ( var it in values) {
		if (values[it] != 'undefined' && values[it] != null && values[it] != '') {
			if (typeof values[it] == 'object') {
				// time zu ISOtimeStr konvertieren
				ret += '&' + encodeURIComponent(it) + '=' + encodeURIComponent(toISOTimeString(values[it]));
			} else {
				ret += '&' + encodeURIComponent(it) + '=' + encodeURIComponent(values[it]);
			}
		}
	}

	return baseUrl + '/' + this._config.searchControllerZF + '/query2?format=json&' + ret;
};

ReasonResultController.prototype.requestResults = function(reftime, roffset, rlimit, more) {
	// return;
	console.info("requestResults(" + toISOTimeString(reftime) + ", " + roffset + "," + rlimit + ")");
	var rdir = rlimit == null ? "older" : (rlimit < 0 ? "newer" : "older");
	more = more == null ? {} : more;
	roffset = roffset == null ? 0 : roffset;
	rlimit = rlimit == null ? this._config.limit : rlimit;
	reftime = reftime == null ? -1 : reftime;

	var qar = this.getNextQAR();
	more["rreftime"] = reftime;
	more["rdir"] = rdir;
	more["roffset"] = roffset;
	more["rlimit"] = rlimit;
	more["qar"] = qar;

	// qar = qar == null ? 0 : qar;
	this.resultsMeta.requestStats[qar] = {
	  params : more, // JSON Object
	  cids2get : {},
	  cidsGot : {},
	  count : 0,
	  error : null,
	  finshed : false
	};
	var requestUrl = this.getLinkRequestUrl(this.resultsMeta.requestStats[qar].params);
	// this.createIntervals();
	// this.addPlaceHolder(qar(), false);
	// isDebug &&
	window.setTimeout(function() {
		isDebug && console.debug("Request: URL\n" + requestUrl);
		$.ajax({
		  type : 'POST',
		  url : requestUrl,
		  dataType : 'json',
		  success : function(results) {
			  console.info('AJAX success');
			  resCtrl.processResults(results);
		  },
		  error : function(xhr, status, ex) {
			  isDebug && console.error('klappt nicht');
			  // resCtrl.handleAjaxError(xhr, status, ex,qar);
		  }
		});
	}, 1000);
};

ReasonResultController.prototype.processResults = function(results) {
	var dirNewer = false;
	var qar = 0;
	if (results.qar != null) {
		qar = results.qar;
	}
	isDebug && console.log('ProcessResults QAR:', qar);
	// if (results.rlimit) {
	// this.resultsMeta.limit = results.rlimit;
	// }
	console.debug('result: ', results);
	if (results.roffset) {
		this.resultsMeta.requestStats[qar].roffset = results.roffset;
	}
	console.debug('roffset ok');
	if (results.reftime) {
		this.resultsMeta.requestStats[qar].rreftime = parseDate(results.reftime);
	}
	console.debug('reftime ok');

	if (results.noresults != null && results.noresults == true) {
		isDebug && console.info(' no results ');
		this.handleNoResults(results, dirNewer);
		this.resultsMeta.requestStats[qar].finished = true;
	} else {
		// delivers abarbeiten

		if (results.delivers != null) {
			isDebug && console.info(' delivers ', results.delivers);

			for ( var i = 0; i < results.delivers.length; i++) {
				results.delivers[i].time = new Date(results.delivers[i].time);
				// @todo connectIDs in request-queue packen
				var cid = this.getConnectID(results.delivers[i]);
				this.resultsMeta.requestStats[qar].cids2get[cid] = cid;
			}
			// results.delivers.sort(sortObjByDateDesc); // lexikografischer vergleich

			// @todo Sortierung implementieren
			var sectionID = this.getIntervalID(results.delivers[0]);
			var section = $('#iv' + sectionID);

			for ( var i = 0; i < results.delivers.length; i++) {
				this.addDeliver(results.delivers[i], section);
				// this.resultsMeta.data[this.getConnectID(results.connects[i])] =
				// results.connects[i];
			}

			$('a.hmt_searchtool_link', section).unbind('click').click(function() {
				alert(resCtrl.getLinkRequestUrl({
				  'rpart' : sectionID,
				  'roffset' : results.roffset,
				  'rreftime' : parseDate(results.reftime)
				}));
				resCtrl.requestResults(parseDate(results.reftime), results.roffset);
			}).attr('href', 'javascript: void(0);' + this.getLinkRequestUrl({
			  'rpart' : sectionID,
			  'roffset' : results.roffset,
			  'rreftime' : parseDate(results.reftime)
			}));

		} else {
			isDebug && console.info(' no delivers ');

		} // if connects

	} // if noresults-else

	if (this.resultsMeta.requestStats[qar].error == null
	    && this.resultsMeta.requestStats[qar].finished != true
	    && (this.resultsMeta.requestStats[qar].count < this.resultsMeta.limit)) {
		if (dirNewer) {
			isDebug && console.info("Should start an other NEWER search.");
			var reqParams = jQuery.extend(true, {}, this.resultsMeta.requestStats[qar].params);
			reqParams.rlimit = this.resultsMeta.limit - this.resultsMeta.requestStats[qar].count;
			isDebug
			    && console.info("Should start an other NEWER search: "
			        + this.getLinkRequestUrl(reqParams));

			// newer
			// this.requestNewerResults(rpart, firsttime, rdir, linklineid, rjump,
			// qar,
			// roffset, rlimit);
		} else {
			// older
			isDebug && console.info("Should start an other OLDER search.");
			var reqParams = jQuery.extend(true, {}, this.resultsMeta.requestStats[qar].params);
			reqParams.rlimit = this.resultsMeta.limit - this.resultsMeta.requestStats[qar].count;
			isDebug
			    && console.info("Should start an other OLDER search: "
			        + this.getLinkRequestUrl(reqParams));
		}
	}
};

ReasonResultController.prototype.addConnect = function(connectObj, rsltGroup) {
	var cID = this.getConnectID(connectObj);
	if ($('#' + cID).length > 0) {
		return;
	}
	if (rsltGroup != null) {
		var resHtml = $(TEMPLATES.result);
		resHtml.attr("id", this.getConnectID(connectObj));
		$('.hmt_result_c_time', resHtml).html(toTimeStr(connectObj.time));
		var tmp = $('.hmt_result_messageId a', resHtml);
		tmp.text(connectObj.c_mid);
		tmp.attr('href', baseUrl + '/' + this._config.searchControllerZF + '/search/c_msgid/'
		    + encodeURIComponent(connectObj.c_mid));
		// @todo link auf messageId-suche setzen
		var mailEntry = $('.hmt_result_mail_from', resHtml);
		mailEntry.text(connectObj.c_mailfrom);
		mailEntry.attr('href', baseUrl + '/' + this._config.searchControllerZF + '/search/c_mail_from/'
		    + encodeURIComponent(connectObj.c_mailfrom));

		$('.hmt_explain_link', resHtml).attr('href',
		    baseUrl + '/mailtrace/explain/show/cid/' + this.getConnectID(connectObj));
		$('.hmt_protocol_link', resHtml).attr('href',
		    baseUrl + '/mailtrace/protocol/show/cid/' + this.getConnectID(connectObj));

		// sortiert einfügen
		if (forward) {
			rsltGroup.after(resHtml);

		} else {
			rsltGroup.before(resHtml);
		}
		resHtml.data('obj', connectObj);
	}
}

/**
 * Fügt einen weiteren Empfänger, der Liste der Empfänger hinzu.
 * 
 * @param deliverObj
 * @param connectHtml
 */
ReasonResultController.prototype.addDeliver = function(deliverObj, connectHtml) {
	// deliver ohne connect wegwerfen
	if (connectHtml.length == 0) {
		console.error('No section to fill in in addDeliver()');
		return;
	}
	// isDebug && alert('connectHtml: '+connectHtml.html());
	// überprüfen, ob deliver schon vorhanden
	if ($('#' + this.getDeliverID(deliverObj), connectHtml).length > 0) {
		return;
	}
	// @todo Die Zeit dürfte nur geupdatet werden, wenn's der neueste stand wäre
	var deliverHtml = $(TEMPLATES.deliver);
	$('.hmt_mailto_station', deliverHtml).attr('id', this.getDeliverID(deliverObj));
	$('.hmt_result_d_time', deliverHtml).text(toTimeStr(deliverObj.time));
	$('.hmt_result_d_status', deliverHtml).text(deliverObj.d_status);
	$('.hmt_result_d_reason', deliverHtml).text(deliverObj.d_rsn);
	$('.hmt_result_d_server', deliverHtml).text(deliverObj.d_srv);
	$('.hmt_result_d_relayhost', deliverHtml).text(deliverObj.d_rh);
	$('a.hmt_detail_link', deliverHtml)
	    .attr(
	        'href',
	        baseUrl + '/mailtrace/protocol/show/did/'
	            + encodeURIComponent(this.getDeliverID(deliverObj)));
	$('.hmt_to_station_more', deliverHtml).click(function() {
		$(this).parents('.hmt_mailto_station').find('div.hmt_mailto_details').toggleClass("toggle");
	});
	$('div.hmt_mailto_details', deliverHtml).addClass(deliverObj.d_status);
	if (null != TEMPLATES.states[deliverObj.d_status]) {
		var img = $('img.hmt_mailto_status', deliverHtml);
		img.attr('src', TEMPLATES.states[deliverObj.d_status].img);
		img.attr('title', TEMPLATES.states[deliverObj.d_status].title);
	}

	$('a.hmt_searchtool_link', connectHtml).before(deliverHtml);
};

ResultController.prototype.addDeliverStackSection = function(connectHtml, deliverObj) {
	//
	var uid = this.getDeliverTraceID(deliverObj);
	var mailHtml = $('#' + uid, connectHtml);
	if (mailHtml.length == 0) {
		// es gibt noch keinen deliver eintrag
		mailHtml = $(TEMPLATES.deliver);
		mailHtml.attr('id', this.getDeliverTraceID(deliverObj));
		mailHtml.data('obj', deliverObj);

		var connectObj = connectHtml.data('obj');
		var mailEntry = $('.hmt_mailto_mail', mailHtml);
		this.replaceReason(deliverObj, connectObj);
		mailEntry.text(deliverObj.d_mailto);
		mailEntry.attr('href', baseUrl + '/' + this._config.searchControllerZF + '/search/d_mail_to/'
		    + encodeURIComponent(deliverObj.d_mailto));
		$('a.hmt_to_station_more', mailHtml).click(
		    function() {
			    $(this).parent().parent().parent().find('div.hmt_mailto_details').toggleClass("toggle")
			        .addClass(deliverObj.d_status);
		    });
		$('a.hmt_to_station_protocol', mailHtml).attr(
		    'href',
		    baseUrl + '/mailtrace/protocol/show/did/'
		        + encodeURIComponent(this.getDeliverID(deliverObj)));
		$('a.hmt_to_station_explain', mailHtml).attr(
		    'href',
		    baseUrl + '/mailtrace/explain/show/did/'
		        + encodeURIComponent(this.getDeliverID(deliverObj)));
		$('div.tracingFrom .tracing_time', mailHtml).html(toTimeStr(connectObj.time));
		// @todo tracingtext (reason) werte mit connect ersetzen
		$('div.tracingFrom .tracing_text', mailHtml).html(connectObj.tevt);
		$('div.tracingFrom .from_email', mailHtml).html(connectObj.c_mailfrom);
	}

	this.updateDeliverState(mailHtml, deliverObj);
	var to = $('.hmt_result_mail_to', connectHtml);
	if (to.children('span').length > 0) {
		to.empty();
	}
	to.append(mailHtml);
	return $(".hmt_tracing .tracingStack", mailHtml);
};

/**
 * 
 * @param tracingStack
 * @param deliverObj
 * @returns
 */
ResultController.prototype.addDeliverTraceStep = function(tracingStack, deliverObj) {
	var station = null;
	var stationTime = null;
	// isDebug && alert("TracingStack "+tracingStack.html());

	$('.hmt_tracing_step', tracingStack).each(function() {
		var time = $(this).data("time");
		// station suchen, die ältere Zeit als deliverObj hat, aber jünger ist
		// als die bisher gefundene
		if (time != null && time >= deliverObj.time && (stationTime == null || stationTime > time)) {
			// isDebug && alert("less Time Obj "+time.toString()+"\nDeliverTime:
			// "+deliverObj.time);
			station = this;
			stationTime = time;
		}
	});
	var tracingStation = $(TEMPLATES.tracing.station);
	tracingStation.attr('id', this.getDeliverID(deliverObj));
	tracingStation.data("obj", deliverObj);
	tracingStation.data("time", deliverObj.time);
	// isDebug && alert("station:"+tracingStation.html());
	// $('.tracingDifference span', tracingStation).text('<zeit-diff>
	// ('+toTimeStr(deliverObj.time)+')');
	$('.tracing_time', tracingStation).text(toTimeStr(deliverObj.time));
	$('.tracing_text', tracingStation).html((deliverObj.tevt ? deliverObj.tevt : deliverObj.d_rsn));
	if (station != null) {
		// isDebug && alert("have station"+station);
		tracingStation.insertBefore(station);
	} else {
		// neueste Station -> auch update des Status
		tracingStack.append(tracingStation);
	}
	return tracingStack;
};

ReasonResultController.prototype.getNextQAR = function() {
	this.resultsMeta.qar_counter++;
	return 'qar' + this.resultsMeta.qar_counter;
};

ReasonResultController.prototype.getIntervalID = function(connectObj) {
	if (connectObj != null) {
		if (connectObj.pt != null) {
			return connectObj.pt;
		} else if (connectObj.time != null) {
			var time = parseDate(connectObj.time);
			return '' + padInteger(time.getFullYear(), 4) + padInteger(time.getMonth() + 1, 2)
			    + padInteger(time.getDate(), 2) + '000000';
			// + padInteger(time.getHours(), 2) + padInteger(time.getMinutes(),
			// 2)+padInteger(time.getSeconds(), 2);
		} else {
			return null;
		}

	}
	return null;
};

ReasonResultController.prototype.createIntervals = function() {
	var content = $('div#result_content');
	console.debug(content.html());
	console.info("ivs: ", this.intervals);
	for ( var iv in this.intervals) {
		console.info("ivs: ", this.intervals[iv]);
		// content.html('<b>'+this.intervals[iv]+'</b>');
		content.text('hallo');
	}
};

ReasonResultController.prototype.getConnectID = function(connectObj) {
	if (connectObj.t == 'c') {
		return this.getIntervalID(connectObj) + 'c' + connectObj.c_id;
	} else {
		return this.getIntervalID(connectObj) + 'c' + connectObj.d_dbid;
	}
};

ReasonResultController.prototype.getDeliverID = function(deliverObj) {
	if (deliverObj.t == 'd') {
		return this.getIntervalID(deliverObj) + 'd' + deliverObj.d_id;
	}
	return null;
};
