<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 15.02.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/Db/Query/PartitionedAbstract.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hmt/Db/Query.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9196 $
 * @since 1.0.9
 */
abstract class Hmt_Db_Query_PartitionedAbstract extends Hmt_Db_Query {
	
	protected $_period;
	/**
	 * Cache für den realen Tabellennamen
	 * @var unknown_type
	 */
	protected $_tableName = null;

	public function __construct($searchArgs = null, Hmt_Db_Query_Constraints $constraints = null, $period = null) {
		parent::__construct($searchArgs, $constraints);
		$this->_period = $period;
	}

	/**
	 * @return the $_period
	 */
	public function getPartition() {
		return $this->_period;
	}

	/**
	 * @param field_type $_period
	 */
	public function setPartition($_period) {
		$this->_period = $_period;
	}

	public function getPartitionTable() {
		if (is_null($this->_tableName)) {
			$this->_tableName = $this->getTablePrefix().$this->getPartition();
		}
		return $this->_tableName;
	}

	abstract protected function getTablePrefix();
}