<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : Aug 14, 2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Utils/Logusing.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
abstract class Hmt_Db_Statistics extends Hpls_Utils_Logusing {
	/**
	 * @todo comment
	 * @var Zend_Db_Adapter_Abstract
	 */
	protected $_db = null;

	public function __construct(Zend_Db_Adapter_Abstract $db) {
		$this->_db = $db;
	}

	abstract function getTupleCountsConnect();

	abstract function getTupleCountsDeliver();

	abstract function getDbSize();

	/**
	 * @todo comment
	 * @return string|int|NULL <b>0</b>: noch nie Vacuum ausgeführt<br/>
	 * <b>null</b>: DB Kommunikationsfehler<br/>
	 * sonst: Datumsstring der Form "YYYY-MM-DD hh:mm:ss.nnnnn+TZ"
	 */
	abstract function getLastReorg();

	abstract function getDeliveryDailyStats($day);
	
	abstract function getDeliveryTimedStats($day);
	
	abstract function getDeliveryServerStats($serverid);
	
	abstract function getConnectDailyStats($day);
	
	abstract function getConnectTimedStats($day);
	
	abstract function getConnectServerStats($serverid);
	
	abstract function getUserDailyStats($day);
	
        public function getRejectTimelineStats(){
                $stats = array();
                $types = array();
                $db = $this->getDb();
                $query = "SELECT s_time, s_type, SUM(s_value) AS val FROM statistics WHERE s_range = 1 GROUP BY s_time, s_type;";
                $stm = $db->query($query);
                foreach ($stm->fetchAll() AS $set){
                        $set['s_time'] = strtotime($set['s_time']) * 1000;
			$stats['days'][$set['s_time']][$set['s_type']] = $set['val'];
                        $types[$set['s_type']] = 1;
                }
                $stats['days'][$set['s_time']] = array_reverse($stats['days'][$set['s_time']], TRUE);
                $query = "SELECT s_time, s_type, SUM(s_value) AS val FROM statistics WHERE s_range = 30 GROUP BY s_time, s_type;";
                $stm = $db->query($query);
                foreach ($stm->fetchAll() AS $set){
                        $set['s_time'] = strtotime($set['s_time']) * 1000;
			$stats['months'][$set['s_time']][$set['s_type']] = $set['val'];   
                        $types[$set['s_type']] = 1;
		}
                $query = "SELECT s_time, s_type, SUM(s_value) AS val FROM statistics WHERE s_range = 365 GROUP BY s_time, s_type;";
                $stm = $db->query($query);
                foreach ($stm->fetchAll() AS $set){
                        $set['s_time'] = strtotime($set['s_time']) * 1000;
			$stats['years'][$set['s_time']][$set['s_type']] = $set['val'];
                        $types[$set['s_type']] = 1;
		}
                $stats['types'] = array_keys($types);
                return $stats;
        }
        
        public function getRejectDailyStats(){
                $stats = array();
                $total = 0;
                $db = $this->getDb();
                $date = date('Y-m-d');
                $query = "SELECT s_type, SUM(s_value) AS val FROM statistics WHERE s_range = 1 AND s_time = '$date' GROUP BY s_type;";
                $stm = $db->query($query);
                foreach ($stm->fetchAll() AS $set){
			$stats['today'][$set['s_type']] = $set['val'];
                        $total += $set['val'];
                }
                $stats['today'][9] = $total;
                $total = 0;
                $date = date('Y-m-' . '01');
                $query = "SELECT s_type, SUM(s_value) AS val FROM statistics WHERE s_range = 30 AND s_time = '$date' GROUP BY s_type;";
                $stm = $db->query($query);
                foreach ($stm->fetchAll() AS $set){
			$stats['month'][$set['s_type']] = $set['val'];
                         $total += $set['val'];
		}
                $stats['month'][9] = $total;
                $total = 0;
                $date = date('Y-' . '01-01');
                $query = "SELECT s_type, SUM(s_value) AS val FROM statistics WHERE s_range = 365 AND s_time = '$date' GROUP BY s_type;";
                $stm = $db->query($query);
                foreach ($stm->fetchAll() AS $set){
			$stats['year'][$set['s_type']] = $set['val'];
                         $total += $set['val'];
		}
                $stats['year'][9] = $total;
                return $stats;
        }

        protected function getConnectTables() {
		return Hpls_Utils::array_values_startWith($this->getTables(), Hmt_Db_Consts::TABLE_CONNECT);
	}

	/**
	 * @todo comment
	 * @return multitype:
	 */
	protected function getTables() {
		$listTables = $this->getDb()->listTables();
		return empty($listTables) ? array() : $listTables;
	}

	/**
	 * @todo comment
	 * @return Zend_Db_Adapter_Abstract
	 */
	protected function getDb() {
		return $this->_db;
	}
}