<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 28.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/LogAbstract.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hmt/Db/Consts.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9196 $
 * @since 1.0.9
 */
abstract class Hmt_LogAbstract implements 
	Hmt_Db_Consts {
	protected static $SHORTEN = array();

	public function __construct($values = null) {
		if (FALSE == is_null($values)) {
			$this->setValues($values);
		}
	}

	public function setValues(array $values) {
		array_change_key_case($values, CASE_LOWER);
		
		foreach ($values as $key => $value) {
			$this->{$this->getSaveKey($key)} = $value;
		}
	}

	abstract public function getUniqueKey();

	public function getPart() {
		return $this->pt;
	}

	abstract static protected function getSaveKey($key);

	protected function toJSdate($timesring) {
		$timesring = explode('.', $timesring);
		if (count($timesring) > 1) {
			
			$timesring[1] = str_pad($timesring[1], 3, "0", STR_PAD_LEFT);
			$timesring[1] = substr($timesring[1], 0, 3);
			return (strtotime($timesring[0]) * 1000) + intval($timesring[1]); // date(Hpls_Consts0::DATE_FORMAT_JS, strtotime($timesring));
		}
		return strtotime($timesring[0]) * 1000; // date(Hpls_Consts0::DATE_FORMAT_JS, strtotime($timesring));
	}

	public function __get($key) {
		return $this->{$this->getSaveKey($key)};
	}

	/**
	 * @todo comment
	 * 
	 * Keine Magic-Methode, da es zu unendlichen Loops kommen könnte.
	 * @param unknown_type $key
	 * @param unknown_type $value
	 */
	public function set($key, $value) {
		$this->{$this->getSaveKey($key)} = $value;
	}

}