<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 10.11.2011
 * created by     : Sebastian Nitzsche <s.nitzsche@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-02-23 09:06:10 +0100 (Do, 23 Feb 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9236 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hmt/Reason/Updater/Mysql.php $
 *
 * author         : Sebastian Nitzsche <s.nitzsche@heinlein-support.de>
 */
/**
 */
require_once 'Hmt/Reason/Updater.php';

class Hmt_Reason_Updater_Mysql extends Hmt_Reason_Updater {
	
	const TEMPLATE_NAME = 'mysql';

	/**
	 *
	 * @return Hmt_Reason_Updater_Mysql
	 */
	public static function i() {
		if (is_null(self::$_instance)) {
			self::$_instance = new self();
		}
		return self::$_instance;
	}

	public function setOptions($options = NULL) {
		$this->_options = $options;
		$this->_dbSource = $options['database'];
		$this->getDbO();
	}

	/**
	 * Lädt die Template-Dateien aus dem Pfad, der in der components.ini (export.templatepath)
	 * angegeben ist.
	 * 
	 * @return void
	 */
	protected function loadTemplates() {
		$this->_sqlkey = self::TEMPLATE_NAME;
		$frontendPath = realpath(APPLICATION_PATH . '/..');
		$tplPath = $frontendPath . $this->_options['conf']->templatepath;
		$tplPathCommon = $frontendPath . $this->_options['conf']->templatepath_common;
		
		if (is_dir($tplPath) && is_dir($tplPathCommon)) {
			$this->_templates[self::TEMPLATE_NAME]['create'] = file_get_contents($tplPathCommon . '/create.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['create_table.reasons'] = file_get_contents($tplPathCommon . '/create_table.reasons.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['alter'] = "";
			$this->_templates[self::TEMPLATE_NAME]['insert.roles'] = file_get_contents($tplPath . '/insert.roles.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.config'] = file_get_contents($tplPath . '/insert.config.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.rules'] = file_get_contents($tplPath . '/insert.rules.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.reasons'] = file_get_contents($tplPath . '/insert.reasons.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['insert.regex'] = file_get_contents($tplPath . '/insert.regex.mysql.tpl.sql');
			$this->_templates[self::TEMPLATE_NAME]['config'] = file_get_contents($tplPath . '/controller.ini');
		} else {
			$this->log()->err("SQL Template Verzeichnis wurde nicht gefunden. ('$tplPath' oder '$tplPathCommon')");
			Hpls_Msgs::i()->addGlobalMsg(Hpls_Msgs::MSG_ERROR, 'hmt_reason_export_mysql', "SQL Template Verzeichnis wurde nicht gefunden. ('$tplPath' oder '$tplPathCommon')");
		}
	}

	protected function processPrepareInserts() {
		$cfg = $this->_config->before;
		
		// TODO: CREATE
		

		// TODO: ALTER TABLE
		

		//	    if ($cfg->disable_trigger == 1) {
		//	        // Trigger abschalten
		//	    }
	}
}