<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 11.04.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
abstract class Hmt_ReasonAbstract {
	const ID_SEP = Hmt_Reason::ID_SEP;

	public function __construct($values = null) {
		if (is_array($values)) {
			$this->setValues($values);
		}
	}

	public function setValues(array $values) {
		foreach ($values as $k => $v) {
			$this->{strtolower($k)} = $v;
		}
	}

	public function __set($k, $v) {
		$this->{strtolower($k)} = $v;
	}

	public function getTimeCreated() {
		return $this->time_created;
	}

	public function getTimeUpdated() {
		return $this->time_updated;
	}

	//	public function __call($fnName,$args) {
	//		if (substr_compare($fnName, 'get', 0,3) ==0) {
	//			return $this->{strtolower(substr($fnName, 3))};
	//		}else {
	//			require_once 'Hpls/Mailtrace/Exception/Reason.php';
	//			throw new Hpls_Mailtrace_Exception_Reason("'$fnName' is not a function.");
	//		}
	//	}
	

	public function getIdS() {
		// TODO Auto-generated method stub
		return $this->id;
	}

	public function getIdT() {
		return $this->id_t;
	}

	public function getID() {
		return $this->getIdS() . self::ID_SEP . $this->getIdT();
	}

	public function isDeactivated() {
		return $this->inactive_state == Hmt_Reason::INACTIVESTATE_INACTIVE;
	}

	public function isDeleted() {
		return $this->inactive_state == Hmt_Reason::INACTIVESTATE_DELETED;
	}

	public function isActive() {
		return $this->inactive_state == Hmt_Reason::INACTIVESTATE_DELETED;
	}

	public function getActiveState() {
		return $this->inactive_state;
	}

	public function getFromtable() {
		return $this->fromtable;
	}

	public function hasID() {
		return !empty($this->id);
	}

	public function getEditUrl() {
	}

	public function getDeleteUrl() {
	
	}

}