<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created   : May 27, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-07-02 16:54:27 +0200 (Mo, 02 Jul 2012) $
 * last changed by: $LastChangedBy: lazee $
 * revision       : $LastChangedRevision: 9532 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Acl/Licence/Reader/Backend.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/**
 */
require_once 'Hpls/Utils.php';
require_once 'Hpls/Acl/Licence/Reader.php';
/**
 *
 * @todo comment
 *      
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *           
 * @package AC
 * @subpackage Rechtesystem
 * @version $LastChangedRevision: 9532 $
 * @since 1.0ufz
 */
class Hpls_Acl_Licence_Reader_Backend extends Hpls_Acl_Licence_Reader {

	/**
	 *
	 * @param $ACL Zend_Acl       	
	 *
	 * @throws Mailapp_Configuration_Exception
	 * @throws Mailapp_Exception_Soap
	 */
	public function loadRules() {
		$soap = $this->getSoap();
		$licenceValues = $soap->readLicense();
		if (is_array($licenceValues)) {
			
			// Expiration?
			
			if ($licenceValues['expiration'] > date('Y-m-d')) {
				
				$licenceValues = array_change_key_case($licenceValues, CASE_LOWER);
				$this->apply($licenceValues);
			}
		}
		
		// Hpls_Utils::log()->debug("Licence LOADED:
	// ".print_r($licenceValues,true));
	}

	/**
	 * instanziiert ein Soap Proxy Objekt.
	 *
	 * @throws Mailapp_Configuration_Exception
	 * @return Mailapp_Soap_Proxy
	 */
	protected function getSoap() {
		$options = Hpls_Application::i()->getFrontController()->getParam(Hpls_Consts::PRM_SOAP);
		
		if (is_null($options))
			throw new Mailapp_Exception_Configuration();
		
		return new Mailapp_Soap_Proxy($options, Hpls_Acl_Consts::LDAP_USER, Hpls_Acl_Consts::LDAP_PASS);
	}

}