<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 14.10.2010
 * created by     : author
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Acl/Licence/Reader/Ini.php $
 * 
 * author         : author
 */
/***/
class Hpls_Acl_Licence_Reader_Ini extends Hpls_Acl_Licence_Reader {
	protected $iniConfig = null;

	public function __construct($iniFile) {
		if (empty($iniFile)) {
			require_once 'Hpls/Exception/Acl/Reader.php';
			throw new Hpls_Exception_Acl_Reader('Parameter $iniFile darf nicht leer sein.');
		} elseif ($iniFile instanceof Zend_Config) {
			$this->iniConfig = $iniFile->toArray();
		} elseif (is_array($iniFile)) {
			$this->iniConfig = $iniFile;
		} elseif (file_exists($iniFile)) {
			$zc = new Zend_Config_Ini($iniFile);
			$this->iniConfig = $zc->toArray();
		} else {
			require_once 'Hpls/Exception/Acl/Reader.php';
			throw new Hpls_Exception_Acl_Reader("Kann übergebene Parameter nicht interpretieren.");
		}
	
	}

	/**
	 * 
	 */
	public function loadRules() {
		isDebug('acl', 'acl_read') && Hpls_Utils::log()->debug(__METHOD__ . Hpls_Debug::print_r($this->iniConfig));
		$licenceValues = array_change_key_case($this->iniConfig, CASE_LOWER);
		$this->apply($licenceValues);
	}

	protected function apply(array $licenceVal) {
		//		if (DEBUG) Hpls_Utils::log()->debug("Old values: ".print_r($licenceVal,true));
		$licenceVal = $this->handleOld($licenceVal);
		//		if (DEBUG) Hpls_Utils::log()->debug("New values: ".print_r($licenceVal,true));
		foreach ($licenceVal as $k => $v) {
			$split = explode(Hpls_Acl_Consts::ID_VAL_SEPARATOR, $k);
			if (count($split) !== 2) {
				Hpls_Utils::log()->warn("Licence: Key '" . $k . "' is not in a valid format.");
			}
			if ($this->_ACL->has($split[0])) {
				/* @var $resObj Hpls_Acl_Resource */
				$resObj = $this->_ACL->get($split[0]);
				$resObj->setValue($split[1], $v);
				$this->applyPrivilege($resObj, $split[1], $v);
			
		//				Hpls_Utils::log()->debug("resObj: $resObj");
			} else {
				isDebug('license') && Hpls_Utils::log()->warn("Resource '" . $split[0] . "' not defined, but the licence has a value for it.");
			}
		}
	}

}