<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created   : May 27, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Acl/Resource.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
/**
 * @see Zend_Acl_Resource_Interface
 */
require_once 'Zend/Acl/Resource/Interface.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage Rechtesystem
 * @version $LastChangedRevision: 9196 $
 * @since 1.0ufz
 */
class Hpls_Acl_Resource implements 
	Zend_Acl_Resource_Interface {
	
	protected $_resourceID = null;
	protected $_values = array();

	/**
	 * Sets the Resource identifier
	 *
	 * @param  string $resourceId
	 * @return void
	 */
	public function __construct($resourceId, array $values = array()) {
		$this->_resourceID = $resourceId;
		$this->_values = $values;
	}

	public function getResourceId() {
		return $this->_resourceID;
	}

	/**
	 * @todo comment
	 * 
	 * @return multitype:mixed
	 */
	public function getValues() {
		return $this->_values;
	}

	public function setValue($key, $value) {
		$this->_values[$key] = $value;
	}

	public function getValue($key) {
		return isset($this->_values[$key]) ? $this->_values[$key] : null;
	}

	public function hasValue($key) {
		return isset($this->_values[$key]) && !is_null($this->_values[$key]);
	}

	public function isExpliciteDisabled() {
		return isset($this->_values['enabled']) && $this->_values['enabled'] === false;
	}

	public function isExpliciteEnabled() {
		return isset($this->_values['enabled']) && $this->_values['enabled'] === true;
	}

	public function __unset($varName) {
		unset($this->_values[$varName]);
	}

	public function __isset($varName) {
		return isset($this->_values[$varName]);
	}

	public function __set($varName, $value) {
		$this->setValue($varName, $value);
	}

	public function __get($varName) {
		return $this->getValue($varName);
	}

	public function __toString() {
		
		return $this->_resourceID . ": values: " . print_r($this->_values, true);
	}
}