<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created   : May 27, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Acl/Role.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
/**
 * @see Zend_Acl_Role_Interface
 */
require_once 'Zend/Acl/Role/Interface.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage Rechtesystem
 * @version $LastChangedRevision: 9196 $
 * @since 1.0ufz
 */
class Hpls_Acl_Role implements 
	Zend_Acl_Role_Interface {
	
	const GUEST = Hpls_Consts0::ROLE_GUEST;
	const LOGGEDIN = Hpls_Consts0::ROLE_LOGGEDIN;
	const USER = Hpls_Consts0::ROLE_USER;
	const MAILUSER = Hpls_Consts0::ROLE_MAILUSER;
	const HELPDESK = Hpls_Consts0::ROLE_HELPDESK;
	/**
	 * Admin des SMTP|IMAP-Servers.
	 * 
	 * Ihm ist erlaubt alle E-Mail des Servers zu 
	 * @var unknown_type
	 */
	const POSTMASTER = Hpls_Consts0::ROLE_POSTMASTER;
	/**
	 * Gleiches wie POSTMASTER, darüber hinaus, aber für ALLE Mail-Server admin.
	 * @var unknown_type
	 */
	const SUPER_POSTMASTER = Hpls_Consts0::ROLE_SUPER_POSTMASTER;
	const ADMIN = Hpls_Consts0::ROLE_ADMIN;
	const SUPER_ADMIN = Hpls_Consts0::ROLE_SUPERADMIN;
	const HPLS_ADMIN = Hpls_Consts0::ROLE_HPLSADMIN;
	
	/**
	 * @var string
	 */
	protected $_roleID = null;

	public function __construct($roleID) {
		$this->_roleID = (string) $roleID;
	}

	/**
	 * @return string
	 */
	public function getRoleId() {
		return $this->_roleID;
	}

}