<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created   : May 31, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-01-04 16:29:57 +0100 (Mi, 04 Jan 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9198 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Acl/ZendExtend.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Zend/Acl.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage Rechtesystem
 * @version $LastChangedRevision: 9198 $
 * @since 1.0ufz
 */
class Hpls_Acl_ZendExtend extends Zend_Acl {
	/**
	 * @var Zend_Acl_Resource_Interface 
	 */
	protected $_rootResource = null;
	
	protected $_currentRequest = array(
			'role' => null,
			'resource' => null,
			'privilege' => null );
	
	protected $_moduleMapping = null;
	
	/**
	 * @todo comment
	 * @var Hpls_Acl
	 */
	protected $_parent = null;

	public function __construct(Zend_Acl_Resource_Interface $rootResource = NULL, Hpls_Acl $parent = null) {
		$this->setRootResource($rootResource);
		$this->_parent = $parent;
	}

	/**
	 * @return Zend_Acl_Resource_Interface the $_rootResource
	 */
	public function getRootResource() {
		return $this->_rootResource;
	}

	/**
	 * @param $_rootResource the $_rootResource to set
	 */
	public function setRootResource(Zend_Acl_Resource_Interface $_rootResource) {
		
		$this->_rootResource = $_rootResource;
		if (!is_null($this->_rootResource)) {
			$this->add($this->_rootResource);
		}
	}

	public function setModuleMapping($map) {
		$this->_moduleMapping = $map;
	}

	public function getCurrentQuery() {
		return $this->_currentRequest;
	}

	public function isAllowed($role = null, $resource = null, $privilege = null) {
		$this->_currentRequest['role'] = $role;
		$this->_currentRequest['resource'] = $resource;
		$this->_currentRequest['privilege'] = $privilege;
		$ret = parent::isAllowed($role, $resource, $privilege);
		$this->_currentRequest['role'] = null;
		$this->_currentRequest['resource'] = null;
		$this->_currentRequest['privilege'] = null;
		//		Hpls_Utils::log()->debug(__METHOD__.": role: $role, res: $resource, op: $privilege >> " . ($ret? "allowed" : "denied"));
		return $ret;
	}

	public function __sleep() {
		return array(
				'_resources',
				'_roleRegistry',
				'_isAllowedRole',
				'_isAllowedResource',
				'_isAllowedPrivilege',
				'_rules',
				'_moduleMapping',
				'_rootResource' );
	}

	public function __wakeup() {
	
	}

	public function __toString() {
		$ret = __CLASS__ . ", Rules: " . print_r($this->_rules, true);
		
		//		foreach ($this->_resources as $k => $v) {
		//			$ret .= "$k => $v";
		//		}
		return $ret;
	}
}