<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 13.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/Application/Config/HtmlView.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Application/ConfigAbstract.php';
require_once 'Zend/Layout.php';

class Hpls_Application_Config_HtmlView extends Hpls_Application_ConfigAbstract {

	/**
	 * 
	 */
	public function init() {
		if ($this->isDontRun()) {
			return null;
		}
		$this->log()->info(__METHOD__ . " START");
		
		$config = $this->getConfig('webui');
		$config = $config['view'];
		require_once 'Hpls/View/Smarty.php';
		
		$view = new Hpls_View_Smarty(array(
				'scriptPath' => $config['scriptPath'],
				'params' => $config['smarty'],
				'helperPath' => array(
						'Hpls_View_Helper_' => 'Hpls/View/Helper',
						'Zend_View_Helper_' => 'Zend/View/Helper' ) ));
		
		$view->doctype('XHTML1_STRICT');
		//        $view->headTitle('My First Zend Framework Application');
		//        $view->debug = isDebug('smarty');
		//        ,basename(__FILE__),false));[&quot;resources&quot;] =&gt; array(8) {
		//    [&quot;frontController&quot;] =&gt; array(3) {
		//      [&quot;baseUrl&quot;] =&gt; string(28) &quot;/hlmailtrace/frontend/public&quot;
		$front = $this->getFrontController();
		$view->baseUrl = $front->getBaseUrl();
		$view->themeUrl = $this->getApplication()->getThemeUrl();
		
		// View Renderer
		Zend_Controller_Action_HelperBroker::getStaticHelper('ViewRenderer')->setViewScriptPathSpec(':module/:controller/:action.:suffix')->setViewSuffix('tpl')->setView($view);
		//		APPLIANCE_PART_PATH.'/templates/Hpls/
		

		// Zend Layout
		// ensure we have layout bootstraped
		

		// set the tpl suffix to layout also
		//        $layout = Zend_Layout::getMvcInstance();
		//        $layout->setViewSuffix('tpl');
		$view->layout = Zend_Layout::startMvc(array(
				'inflectorTarget' => ':script.:suffix', //layout/:script.:suffix
				'layout' => 'page',
				'viewSuffix' => 'tpl' ))->setView($view);
		return $view;
	}

}