<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 13.10.2010
 * created by     : author
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/Application/Config/I18n.php $
 * 
 * author         : author
 */
/***/
require_once 'Hpls/Application/ConfigAbstract.php';

class Hpls_Application_Config_I18n extends Hpls_Application_ConfigAbstract {

	/**
	 * 
	 */
	public function init() {
		isDebug('config_plugins_init') && $this->log()->info(__METHOD__);
		$this->initLocale();
		$this->initTranslate();
	}

	/**
	 *
	 */
	protected function getI18Nconfig() {
		return $this->getConfig(Hpls_Consts::CFG_I18N);
	}

	/**
	 *
	 */
	protected function initLocale() {
		$i18n = $this->getI18Nconfig();
		$locale = NULL;
		if (!empty($i18n[Hpls_Consts::CFG_I18N_LANG])) {
			$locale = $i18n[Hpls_Consts::CFG_I18N_LANG];
		}
		Zend_Registry::set(Hpls_Consts::REGK_LOCALE, new Zend_Locale($locale));
	}

	/**
	 *
	 */
	protected function getLocale() {
		return Zend_Registry::get(Hpls_Consts::REGK_LOCALE);
	}

	/**
	 *
	 */
	protected function initTranslate() {
		$i18n = $this->getI18Nconfig();
		$defaultFile = $i18n[Hpls_Consts::CFG_I18N_PATH] . '/default/';
		$defaultFile .= $this->getLocale()->getLanguage() . $i18n[Hpls_Consts::CFG_I18N_EXT];
		$cache = Hpls_Utils::getCache('Core');
		Zend_Translate::setCache($cache);
		$translate = new Zend_Translate($i18n[Hpls_Consts::CFG_I18N_ADAPTER], $defaultFile, $this->getLocale()->getLanguage());
		$this->loadComponentI18N($translate);
		Zend_Registry::set(Hpls_Consts::REGK_I18N, $translate);
	}

	/**
	 * @todo fallback to default language
	 */
	protected function loadComponentI18N(Zend_Translate &$translate) {
		$i18n = $this->getI18Nconfig();
		$comps = Zend_Registry::get(Hpls_Consts::REGK_COMPONENTS);
		$lang = $this->getLocale()->getLanguage();
		$langFile = $lang . $i18n[Hpls_Consts::CFG_I18N_EXT];
		foreach ($comps as $comp => $values) {
			$file = $i18n[Hpls_Consts::CFG_I18N_PATH] . '/' . $comp . "/$langFile";
			$this->log()->debug("I18N: comp lang file: $file");
			if (file_exists($file)) {
				$translate->addTranslation($file, $lang);
			}
		}
	}

}