<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 18.10.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Application/ConfigAbstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since Magdeburg:Produktiv2
 */
class Hpls_Application_Config_Session extends Hpls_Application_ConfigAbstract {

	/**
	 * 
	 */
	public function init() {
		if ($this->getApplication()->isStandAlone()) {
			$this->initStandalone();
		} else {
			$this->initMailapp();
		}
	}

	protected function initStandalone() {
		$cfgSession = $this->getConfig('session');
		Zend_Session::setOptions($cfgSession);
	}

	protected function initMailapp() {
		$cfgSession = $this->readMailappConfig();
		Zend_Session::setOptions($cfgSession);
	}

	protected function readMailappConfig() {
		$ini = new Zend_Config_Ini(Hpls_Consts::FILEPATH_CONFIG_MAILAPP_FRONTEND, 'session');
		return $ini->toArray();
	}

}