<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 24, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/Application/ConfigAbstract.php $
 *
 */
/**
 *
 */
require_once 'Hpls/Consts.php';
require_once 'Zend/Config/Ini.php';

/**
 * @todo comment
 *
 * Base class for HPLS Zend_Application resource plugins, which provides easy access to a logger.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9196 $
 * @since rc
 */
abstract class Hpls_Application_ConfigAbstract {
	/**
	 * @var Zend_Log
	 */
	private $_logger = NULL;
	private $_application = null;
	private $_dontRun = false;

	abstract public function init();

	final public function __construct(Hpls_Application $app) {
		$this->_application = $app;
	}

	function __get($varname) {
		if (strcasecmp('logger', $varname) === 0) {
			return $this->getLogger();
		}
		return NULL;
	}

	/**
	 * @todo comment
	 *
	 * @return Zend_Log
	 */
	protected function log() {
		if (NULL === $this->_logger) {
			
			$this->_logger = Zend_Registry::get(Hpls_Consts::REGK_LOGGER);
		}
		return $this->_logger;
	}

	protected function getConfig($section) {
		return $this->getApplication()->getConfig($section);
	}

	protected function getFrontController() {
		return $this->getApplication()->getFrontController();
	}

	protected function getApplicationConfigurer($classname) {
		return $this->getApplication()->getConfigurer($classname);
	}

	/**
	 * @todo comment
	 * 
	 * @return Hpls_Application
	 */
	protected function getApplication() {
		return $this->_application;
	}

	/**
	 * @param string $filename
	 * @param string $section
	 * @return Zend_Config
	 */
	protected function readIniCascaded($filename, $section = null, array $forProducts = array()) {
		return Hpls_Utils::readConfigIniCascade($filename, $section);
	}

	/**
	 * @return the $_dontRun
	 */
	public function isDontRun() {
		return $this->_dontRun;
	}

	/**
	 * @param field_type $_dontRun
	 */
	public function setDontRun($_dontRun) {
		$this->_dontRun = $_dontRun;
	}

}