<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 26.07.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Auth/Reader/UserdataAbstract.php';
require_once 'Zend/Validate/EmailAddress.php';

/**
 * Eine Klasse für persistierte Informationen über den User, die sich die Daten aus
 * dem Login ableitet. Diese Klasse greift auf keinerlei externen Speicher zu.
 * 
 * 
 * Zum Beispiel kann aus einem Login, bei dem der Anmeldename eine E-Mail-Adresse ist,
 * diese und nur diese E-Mail-Adresse für getManagedEmails() genommen werden. 
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hpls_Auth_Reader_Userdata_Login extends Hpls_Auth_Reader_UserdataAbstract {
	/**
	 * @todo comment
	 * @var Zend_Validate_EmailAddress
	 */
	protected $_validator = null;

	public function __construct($name, $options) {
		parent::__construct($name, $options);
		$this->_validator = new Zend_Validate_EmailAddress();
	}

	/* (non-PHPdoc)
	 * @see Hpls_Auth_Reader_UserdataInterface::getManagedDomains()
	 */
	public function getManagedDomains($username) {
		// TODO Auto-generated method stub
		return array();
	}

	/* (non-PHPdoc)
	 * @see Hpls_Auth_Reader_UserdataInterface::getManagedEmails()
	 */
	public function getManagedEmails($username) {
		// TODO Auto-generated method stub
		if ($this->_validator->isValid($username)) {
			return array(
					$username );
		}
		return array();
	}

	/* (non-PHPdoc)
	 * @see Hpls_Auth_Reader_UserdataInterface::checkOptions()
	 */
	public function checkOptions() {
		// TODO Auto-generated method stub
	

	}

	/* (non-PHPdoc)
	 * @see Hpls_Storage_ReaderInterface::connect()
	 */
	public function connect() {
		// TODO Auto-generated method stub
	

	}

	/* (non-PHPdoc)
	 * @see Hpls_Storage_ReaderInterface::disconnect()
	 */
	public function disconnect() {
		// TODO Auto-generated method stub
	

	}

	/* (non-PHPdoc)
	 * @see Hpls_Storage_ReaderInterface::getValues()
	 */
	public function getValues() {
		// TODO Auto-generated method stub
	

	}

	/* (non-PHPdoc)
	 * @see Hpls_Auth_Reader_UserdataAbstract::getData()
	 */
	public function getData($username = null) {
		// TODO Auto-generated method stub
	

	}

}