<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created   : Jul 29, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Cli/Command/StackedAbstract.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Cli/Command/Abstract.php';

abstract class Hpls_Cli_Command_StackedAbstract extends Hpls_Cli_Command_Abstract {
	protected $_commandStack = NULL;

	public function __construct($owner, array $cmdLineOptions, array $cmdStack = array()) {
		parent::__construct($owner, $cmdLineOptions);
		$this->setCommandStack($cmdStack);
	}

	/**
	 * 
	 */
	function exec() {
		foreach ($this->_commandStack as $command => $options) {
			$cmdInstance = $this->getOwner()->runCommand($command, $options['cmdline']);
		
		}
	}

	/**
	 * 
	 */
	function parseCmdLine() {
	
	}

	/**
	 * @param array $cmdStack
	 * <ul>
	 * <li>[<command_name>]
	 * ['cmdline']
	 * ['return']
	 * </ul>
	 */
	function setCommandStack(array $cmdStack) {
		$this->_commandStack = array();
		foreach ($cmdStack as $cmd => $options) {
			if (empty($options['cmdline'])) {
				$options['cmdline'] = array();
			}
			if (!is_array($options['cmdline'])) {
				$options['cmdline'] = array(
						$options['cmdline'] );
			}
			$this->_commandStack[$cmd] = $options;
		}
	}

	function getCommandStack() {
	
	}

}