<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 22.06.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Zend/Config/Writer/Xml.php';
class Hpls_Config_Writer_Xml extends Zend_Config_Writer_Xml {
	protected $_valueAsAttr = true;

	protected function _addBranch(Zend_Config $config, SimpleXMLElement $xml, SimpleXMLElement $parent) {
		$branchType = null;
		
		foreach ($config as $key => $value) {
			if ($branchType === null) {
				if (is_numeric($key)) {
					$branchType = 'numeric';
					$branchName = $xml->getName();
					$xml = $parent;
					
					unset($parent->{$branchName});
				} else {
					$branchType = 'string';
				}
			} else if ($branchType !== (is_numeric($key) ? 'numeric' : 'string')) {
				require_once 'Zend/Config/Exception.php';
				throw new Zend_Config_Exception('Mixing of string and numeric keys is not allowed');
			}
			
			if ($branchType === 'numeric') {
				if ($value instanceof Zend_Config) {
					$child = $parent->addChild($branchName);
					
					$this->_addBranch($value, $child, $parent);
				} else {
					if ($this->_valueAsAttr) {
						$child = $parent->addChild($branchName);
						$child->addAttribute('value', (string) $value);
					} else {
						$parent->addChild($branchName, (string) $value);
					}
				}
			} else {
				if ($value instanceof Zend_Config) {
					$child = $xml->addChild($key);
					
					$this->_addBranch($value, $child, $xml);
				} else {
					if ($this->_valueAsAttr) {
						$child = $xml->addChild($key);
						$child->addAttribute('value', (string) $value);
					} else {
						$parent->addChild($branchName, (string) $value);
					}
				}
			}
		}
	}

}