<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 03.05.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Consts.php';

interface Hpls_Constraint_Consts {
	const REQ_KEY_RESULTS = Hpls_Consts::CONSTRAINTS_RESULTS_REQUESTKEY;
}

interface Hpls_Constraint_Interface {

	/**
	 * Wendet das Constraint auf das|die Felder $field an.
	 * 
	 * Ist das Constraint ein reiner Check, so gibt die Funktion einen boolean-Wert zurück,
	 * der signalisiert, ob der Test bestanden wurde.
	 * 
	 * Ist es nur eine Transformation (z.B. Unifizierung) gibt die Funktion nichts zurück,
	 * die Transformationsergebnisse werden direkt in den $request geschrieben.
	 * 
	 * Fehlernachrichten werden im Hpls_Msgs-Singleton für das jeweilige Feld mit dem
	 * Constraint-Klassennamen als $category der Message hinterlegt.
	 * 
	 * @param string|array $fields Der (HTML-) Feldname(n), dessen Werte überprüft werden sollen. Unter diesem
	 * Namen ist der Wert im $request auffindbar.
	 * @param Zend_Controller_Request_Abstract $request Der initialisierte Request in den auch Ergebnisse geschrieben werden können.
	 * @return void|boolean
	 */
	public function apply($fields, Zend_Controller_Request_Abstract $request);

	/**
	 * @todo comment
	 * @param array $options
	 */
	public function setOptions($options);

	/**
	 * @return string eine ID, die die Klasse des Checkers eindeutig identifiziert.
	 * Bei direkten Implementierungen der Klassenname, bei Wrappern, der Klassenname, der gewrappten Klasse.
	 */
	public function getCheckerID();
}