<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : 14.06.2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/Constraint/Validate/Date.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 */
/***/
require_once 'Zend/Validate/Date.php';
require_once 'Hpls/Constraint/Unifier/Date.php';
require_once 'Hpls/Constraint/Interface.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package HPLS
 * @subpackage subpackage
 * @version $LastChangedRevision: 9196 $
 * @since alpha.1
 *
 */
class Hpls_Constraint_Validate_Date extends Zend_Validate_Date implements 
	Hpls_Constraint_Interface {
	/**
	 * @var Hpls_Unifier_Date
	 */
	protected $_unifierDate = null;
	protected $_formats = array(
			'/^\d{4}-\d{2}-\d{2}$/' /* ISO */
	,'/^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\+\d{4})?$/' );

	public function __construct() {
		$this->_unifierDate = new Hpls_Unifier_Date();
	}

	public function isValid($date) {
		$date = trim($date);
		$format = $this->_unifierDate->getFormat($date);
		if ($format !== false) {
			if ($format === Zend_Date::TIMESTAMP) {
				//workaround für timestamps, da die nicht vernünftig validiert werden -> irgendwas stimmt da nicht mit der timezone, denk ich
				$date = new Zend_Date($date);
			} else {
				$this->setFormat($format);
			
			}
			
			return parent::isValid($date);
		}
		$this->_messages[self::FALSEFORMAT] = "'$date' entspricht keinem unterstützten Datumsformat.";
		
		return false;
	
		//		return parent::isValid($date);
	}

	/* (non-PHPdoc)
	 * @see Hpls_Constraint_Interface::apply()
	 */
	public function apply($field, Zend_Controller_Request_Abstract $request) {
		// TODO Auto-generated method stub
		return $this->isValid($date);
	}

	/* (non-PHPdoc)
	 * @see Hpls_Constraint_Interface::setOptions()
	 */
	public function setOptions($options) {
		// TODO Auto-generated method stub
	

	}

	/* (non-PHPdoc)
	 * @see Hpls_Constraint_Interface::getCheckerID()
	 */
	public function getCheckerID() {
		// TODO Auto-generated method stub
	

	}

}