<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 04.05.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Constraint/ValidateAbstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hpls_Constraint_ZendValidateWrapper extends Hpls_Constraint_ValidateAbstract {
	
	protected $_toWrapName = null;
	protected $_toWrapInstance = null;

	/* (non-PHPdoc)
	 * @see Hpls_Constraint_Interface::apply()
	 */
	public function apply($field, Zend_Controller_Request_Abstract $request) {
		// TODO Auto-generated method stub
		if (is_null($field)) {
			throw new InvalidArgumentException('Field must not be <null>.', 1);
		}
		if (!is_array($field)) {
			$field = array(
					$field );
		}
		$ret = true;
		foreach ($field as $f) {
			$value = $request->getParam($f, null);
			$result = $this->getWrappedInstance()->isValid($value);
			if (false === $result) {
				$this->addFieldError($f, array_merge($this->getWrappedInstance()->getErrors(), $this->getWrappedInstance()->getMessages()),0,$this->_toWrapName);
				$ret = false;
			}
		
		//				$request->setParam($f, $this->getWrappedInstance()->isValid($value));
		}
		return $ret;
	}

	/* (non-PHPdoc)
	 * @see Hpls_Constraint_Interface::setOptions()
	 */
	public function setOptions($options) {
		// TODO Auto-generated method stub
		parent::setOptions($options);
		$this->_toWrapName = $options['towrap'];
	
	}

	/* (non-PHPdoc)
	 * @see Hpls_Constraint_Interface::getCheckerID()
	 */
	public function getCheckerID() {
		// TODO Auto-generated method stub
		return $this->_toWrapName;
	}

	/**
	 * @todo comment
	 * @return Zend_Validate
	 */
	protected function getWrappedInstance() {
		if (is_null($this->_toWrapInstance)) {
			$className = $this->_toWrapName;
			$path = explode('_', $className);
			
			require_once implode(DIRECTORY_SEPARATOR, $path) . '.php';
			$this->_toWrapInstance = new $className();
		}
		return $this->_toWrapInstance;
	}

}