<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 02.05.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Controller/Plugin/Abstract.php';

/**
 * Wendet
 * - Unification
 * - Validation
 * - Policies
 * auf die im Request enthaltenen Parameter an und schreibt sein Ergebnis entsprechend... (wohin denn?)
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 */
class Hpls_Controller_Plugin_Constraints extends Hpls_Controller_Plugin_Abstract {

	public function preDispatch(Zend_Controller_Request_Abstract $request) {
		//		isDebug('trace_plugins') && 
		$this->log()->debug(__METHOD__ . " (m: " . $request->getModuleName() . " c: " . $request->getControllerName() . " a: " . $request->getActionName());
		if (!empty($_GET) || !empty($_POST)) {
			if ($this->isUnificationToApply($request)) {
				require_once 'Hpls/Unifier.php';
				Hpls_Unifier::i()->apply($request);
			}
			if ($this->isValidationToApply($request)) {
				require_once 'Hpls/Validate.php';
				Hpls_Validate::i()->apply($request);
			}
			if ($this->isPolicyToApply($request)) {
				require_once 'Hpls/Policy.php';
				Hpls_Policy::i()->apply($request);
			}
		}
	}

	protected function isUnificationToApply(Zend_Controller_Request_Abstract $request) {
		return true;
	}

	protected function isValidationToApply(Zend_Controller_Request_Abstract $request) {
		return true;
	}

	protected function isPolicyToApply(Zend_Controller_Request_Abstract $request) {
		return true;
	}

}