<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created   : Aug 22, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Exception/Executable/Wrapper.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Exception/Cli.php';

/**
 * Exception für Konfigurations-/Kommandozeilenoptionsfehler von CLI-Tools.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC
 * @subpackage CLI-UI
 * @version $LastChangedRevision: 9196 $
 * @since 1.0.0.5
 */
class Hpls_Exception_Executable_Wrapper extends Hpls_Exception_Cli {
	protected $host;
	protected $cmd;
	protected $cmdOptions;

	public function __construct($message, $code, $cmd, $host, $cmdOptions = null) {
		parent::__construct($message, $code);
		$this->host = $host;
		$this->cmd = $cmd;
		$this->cmdOptions = $cmdOptions;
	}

	/**
	 * @return the $host
	 */
	public function getHost() {
		return $this->host;
	}

	/**
	 * @return the $cmd
	 */
	public function getCmd() {
		return $this->cmd;
	}

	/**
	 * @return the $cmdOptions
	 */
	public function getCmdOptions() {
		return $this->cmdOptions;
	}

}