<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 18.12.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2010-12-19 15:27:52 +0100 (So, 19 Dez 2010) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 8058 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Exception/NotImplemented.php $
 *
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Exception.php';

/**
 * Exception, die geworfen werden sollte, wenn eine Funktion zwar schon in der Signatur existiert, aber noch keine Implementierung hat und implementiert werden sollte.
 *
 * <p>
 * Hiermit kann ein Grundgerüst entworfen werden und Stellen als zu implementieren gekennzeichnet werden, ohne dass man sie jemals wieder vergessen könnte. Wenn nur Kommentare
 * verwendet würden, gibt's keine Fehlermeldung, wenn die Funktion doch verwendet wird.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 8058 $
 * @since 1.0.7
 */
class Hpls_Exception_NotImplemented extends Hpls_Exception {

	//const ERR_DEFAULT_COMP_MIN = "At least the 'default' HPLS- component should";
	public function __construct($message, $code = 100) {
		parent::__construct($message, $code);
	}

}