<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 29, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-02-23 14:29:54 +0100 (Do, 23 Feb 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9237 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/HMT/GUI/Core/trunk/hpls.hmt.gui.libs/Hpls/Mailtrace/Consts.php $
 *
 */
/**
 *
 */

/**
 * Constants used throughout the Mailtrace component.
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package HPLS
 * @subpackage subpackage
 * @version $LastChangedRevision: 9237 $
 * @since alpha.1
 *
 */

interface Hpls_Mailtrace_Consts {
	const COMP_NAME = 'HMT';
	
	const V_MT_EXPLAIN = 'mt_explain';
	const V_MT_EXPLAIN_TEXT = 'text';
	const V_MT_EXPLAIN_LINK = 'link';
	
	const DAEMON_DEFAULT_ONOFF = 'no';
	const DAEMON_DEFAULT_CONF_KEY = 'start';
	const DAEMON_DEFAULT_ROTATE = '4d';
//	const DAEMON_CONF_SECTION_KEY = 'general';
//	const DAEMON_CONF_OPERATIONAL_KEY = 'operational';
	
	//[mtlog]
	const CONF_MTLOG = 'mtlog';
	//[mtlog]/reason.*
	const CONF_REASON = 'reason';
	const CONF_REASON_FILE = 'configPath';
	const CONF_REASON_TEXTDIR = 'textDir';
	//[mtlog]/storage.db.type 
	const CONF_STORAGE = 'storage';
	const CONF_STORAGE_DB = 'db';
	const CONF_STORAGE_DB_TYPE = 'type';
	const CONF_STORAGE_DB_NAME = 'dbname';
	const CONF_STORAGE_DB_HOST = 'host';
	const CONF_STORAGE_DB_PORT = 'port';
	const CONF_STORAGE_DB_PASSWORD = 'password';
	const CONF_STORAGE_DB_USER = 'username';
	
	const SRCH_ARRAY = 'hmt_srch';
	
	const SRCH_C_ID = 'c_id';
	const SRCH_MAILFROM = 'c_mail_from';
	const SRCH_C_MAIL_FROM_ADR = 'c_mail_from_adr';
	const SRCH_C_MAIL_FROM_DMN = 'c_mail_from_domain';
	const SRCH_C_TIME = 'c_time';
	const SRCH_C_UTIME = 'c_utime';
	const SRCH_MX = 'c_mxname';
	const SRCH_CLIENT = 'c_client';
	const SRCH_C_CLIENT_IP = 'c_client_ip';
	const SRCH_C_CLIENT_HOST = 'c_client_host';
	const SRCH_C_QUEUE_ID = 'c_queue_id';
	const SRCH_MSG_ID = 'c_msgid';
	const SRCH_SIZE = 'c_size';
	
	const SRCH_D_ID = 'd_id';
	const SRCH_D_DBID = 'd_dbid';
	const SRCH_MAILTO = 'd_mail_to';
	const SRCH_D_MAILTO_ADR = 'd_mail_to_adr';
	const SRCH_D_MAILTO_DMN = 'd_mail_to_domain';
	const SRCH_D_ORIGINAL_MAILTO = 'd_orig_to';
	const SRCH_D_ORIGINAL_MAILTO_ADR = 'd_orig_to_adr';
	const SRCH_D_ORIGINAL_MAILTO_DMN = 'd_orig_to_domain';
	const SRCH_D_TIME = 'd_time';
	const SRCH_D_UTIME = 'd_utime';
	const SRCH_RELAY_HOST = 'd_relayhost';
	const SRCH_D_QUEUE_ID = 'd_queue_id';
	const SRCH_STATUS = 'd_status';
	const SRCH_REASON = 'd_reason';
	
	const SRCH_S_ID = 's_id';
	const SRCH_S_NAME = 's_name';
	
	const SRCH_V_DATE_TO = 'v_date_To';
	const SRCH_V_DATE_FROM = 'v_date_from';
	const SRCH_V_HOSTS = 'v_hosts';
	
	const SRCH_STATUS_UNKNOWN = 'unknown';
	
	const RESOPT_ARRAY = 'resOpt';
	
	const RESOPT_LIMIT = 'rlimit';
	const RESOPT_OFFSET = 'roffset';
	const RESOPT_SEARCH_START_TIME = 'rtime';
	const RESOPT_SEARCH_REF_TIME = 'rreftime';
	const RESOPT_DIRECTION = 'rdir';
	const RESOPT_PARTITION = 'rpart';
	const RESOPT_TIME_JUMP = 'rjump';
	const RESOPT_TIME_JUMP_REF = 'rtime';
	const RESOPT_QAR = 'qar';
	
	const RESOPT_ITEMS = 'resItems';
	const RESOPT_PAGE = 'res_page';
	const RESOPT_PAGE_DEFAULT = 1;
	const RESOPT_SORT_COL = 'resSortCol';
	const RESOPT_SORT_ASC = 'resSortAsc';
	const RESOPT_SORT_ASC_VAL_ASC = 1;
	const RESOPT_SORT_ASC_VAL_DESC = 0;
	const RESOPT_SORT_ASC_DEFAULT = self::RESOPT_SORT_ASC_VAL_ASC;
	const RESOPT_LIMIT_DEFAULT = 25;
	const RESOPT_DIRECTION_DEFAULT = 'older';
	const RESOPT_DIRECTION_NEWER = 'newer';
	const RESOPT_DIRECTION_OLDER = 'older';
	const RESOPT_SORT_COL_VAL_NOSORT = '-';
	
	const RESOPT_DEBUG_NOREGEX = 'resNoRegExMatch';
	const RESOPT_DEBUG_NOREGEX_DEFAULT = 0;
	/**
	 * '-' -> no sort 
	 * @var string
	 */
	const RESOPT_SORT_COL_DEFAULT = self::RESOPT_SORT_COL_VAL_NOSORT;
	
	const SRCH_SUBMIT = 'submitSrch';
	
	/**
	 * @var string Reason.ini [global] section key name 
	 */
	const REASON_INI_GLOBAL = 'global';
	const REASON_GLOBAL_DEFAULT = 'default';
	const REASON_GLOBAL_DEFAULT_ROLE = 'role';
	const REASON_GLOBAL_DEFAULT_LOCALE = 'language';
	const REASON_GLOBAL_DEFAULT_ROLE_DEFAULT = 'user';
	const REASON_GLOBAL_DEFAULT_LOCALE_DEFAULT = 'de';
	/**
	 * @var string Rules section key name
	 */
	const REASON_INI_RULES = 'rules';
	
	const REASON_RULE_REGEX = "rule";
	const REASON_RULE_VARNAMING = 'p';
	const REASON_RULE_SHORT = 'short';
	const REASON_RULE_HELPTEXT = 'helpText';
	const REASON_RULE_HELPFILE = 'helpFile';
	const REASON_RULE_HELPLINK = 'helpLink';
	
	const CONFIG_KEY_CACHEDB = 'cachedb';
	const CONFIG_KEY_VENDORDB = 'vendor';
	const CONFIG_KEY_CUSTORMERDB = 'customer';
	
	const FILE_EXTENSION_REASON_UPDATE = '.hmtruf';
	
	const ERR_QUERY_EMAIL = Hpls_Err::ERR_QUERY_EMAIL;
}

interface MTConsts extends 
	Hpls_Mailtrace_Consts {

}