<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created   : 06.09.2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Utils.php';
require_once 'Hpls/Utils/Logusing.php';
require_once 'Hpls/Acl.php';
require_once 'Hpls/Navigation/Page/Tab.php';
require_once 'Hpls/Navigation/Page/Uri.php';
require_once 'Hpls/Navigation/Page/Controller.php';
require_once 'Hpls/Navigation/Page/Root.php';
require_once 'Zend/Filter/Alnum.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since ??
 */
class Hpls_Navigation extends Hpls_Utils_Logusing {
	protected static $_instance = null;
	/**
	 * @var Hpls_Navigation_Page_Root
	 */
	protected $_navTree = null;
	protected $_idMap = array();

	/**
	 * @todo comment
	 * 
	 * @return Hpls_Navigation
	 */
	public static function i() {
		if (is_null(self::$_instance)) {
			self::$_instance = new Hpls_Navigation();
		}
		return self::$_instance;
	}

	protected function __construct() {
		$this->setLogger(Hpls_Utils::getLogger());
	
		//		$content = @file_get_contents($path)
	}

	protected function __clone() {
	
	}

	/**
	 * 
	 */
	/**
	 * @param unknown_type $productTab
	 * @return Zend_Navigation_Container
	 */
	public function getNavigation($productTab) {
		$tree = $this->getNavTree();
		return $tree->findOneBy('id', $productTab);
	}

	public function getActiveTab() {
		$tree = $this->getNavTree();
		foreach ($tree as $tab) {
			//			isDebug('navigation') && $this->log()->debug(Hpls_Debug::print_r($tab, __METHOD__));
			if ($tab->isActive(true)) {
				return $tab;
			}
		}
		return null;
	}

	/**
	 * @todo comment
	 * 
	 * @param unknown_type $id
	 * @return Zend_Navigation_Page
	 */
	public function getByID($id) {
		$ret = $this->getNavTree()->findBy('id', $id);
		if (is_null($ret)) {
			require_once 'Hpls/Exception/Navigation.php';
			throw new Hpls_Exception_Navigation("ID '$id' does not exists in navigation tree.");
		}
		return $ret;
	}

	public function assignNavigation(Zend_View_Interface $view) {
	
	}

	/**
	 * @return Hpls_Navigation_Page_Tab
	 */
	public function getCurrentTab() {
		//		$this->getNavTree()->
	}

	/**
	 * @todo comment
	 * 
	 * @return Hpls_Navigation_Page_Root
	 */
	public function getNavTree() {
		if (is_null($this->_navTree)) {
			$this->loadNavigation();
		
		}
		return $this->_navTree;
	}
	
	public function removePage($pageID) {
		
	}

	protected function loadNavigation() {
		$cache = Hpls_Utils::getCache();
		$sessRefIf = Hpls_Application0::i()->getSessionRefId();
		$username = Hpls_Auth::i()->getUsername();
		$username = empty($username) ? '' : $username;
		$filter = new Zend_Filter_Alnum(false);
		$cacheidTree = $filter->filter("$sessRefIf${username}_nav_tree");
		$cacheidIdmap = $filter->filter("$sessRefIf${username}_nav_idmap");
		$navtree = $cache->load($cacheidTree);
		if ($navtree === false) {
			require_once 'Hpls/Navigation/Loader.php';
			$loader = new Hpls_Navigation_Loader();
			$this->_navTree = $loader->getResult();
			$this->_idMap = $loader->getIdMap();
			isDebug('config_read', 'navigation') && $this->log()->debug(Hpls_Debug::print_r($this->_navTree, __METHOD__));
			
			$cache->save($this->_navTree, $cacheidTree, array(
					'session',
					'nav' ));
		
		} else {
			
			$this->_navTree = $navtree;
			$this->regenerateIdMap($this->_navTree);
		}
		
		$page = $this->_navTree->findBy('id', 'tab_login');
		if (!empty($page)) {
			if (!empty($username)) {
				$page->setLabel('tab_logout');
				$page->setHref(null);
				$page->setController('logout');
			} else {
				$page->setLabel('tab_login');
				$page->setHref(null);
				$page->setController('login');
			}
			
			if (file_exists('/etc/mailapp_version')) {
				$page = $this->_navTree->findBy('id', 'tab_login');
 				$page->setLabel('back_to_mailapp');
 				$page->setHref('/admin/overview/show');
				
//				$page = $this->_navTree->findBy('id', 'tab_login');
//				$page->setHref('/admin/authentication/logout');
			}
		}
	
	}

	protected function regenerateIdMap($startPage) {
		foreach ($startPage as $page) {
			$this->_idMap[$page->getId()] = $page;
			$this->regenerateIdMap($page);
		}
	}
}
