<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 23.08.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-02-21 15:00:14 +0100 (Di, 21 Feb 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9222 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.common/Hpls/Settings/Handler/Component.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/**
 */
require_once 'Hpls/Settings/HandlerAbstract.php';
require_once 'Hpls/Application.php';

/**
 *
 * @todo comment
 *      
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *           
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision: 9222 $
 * @since 1.0.9
 */
class Hpls_Settings_Handler_Component extends Hpls_Settings_HandlerAbstract {
	protected $_componentName = null;
	protected $_configDir = null;

	public function __construct($componentName, $key = null, $configDir = null) {
		parent::__construct($key);
		$this->_componentName = strtoupper(trim($componentName));
		$this->_configDir = $configDir;
	}

	public function save($key = null) {
		require_once 'Hpls/Config/Writer/Ini.php';
		$dir = empty($this->_configDir) ? Hpls_Application0::i()->getVariableConfigDir($this->_componentName) : $this->_configDir;
		$file = $dir . DIRECTORY_SEPARATOR . Hpls_Consts0::FILE_CONFIG_COMPONENT;
		$writer = new Hpls_Config_Writer_Ini();
		$writer->write($file, $this->_configData);
	}
	
	/*
	 * (non-PHPdoc) @see Hpls_Settings_HandlerAbstract::load()
	 */
	public function load($key = null) {
		$dir = empty($this->_configDir) ? Hpls_Application0::i()->getVariableConfigDir($this->_componentName) : $this->_configDir;
		$filenameETC = $dir . DIRECTORY_SEPARATOR . Hpls_Consts0::FILE_CONFIG_COMPONENT;
		$filename = Hpls_Application0::i()->getAppsConfigPath() . DIRECTORY_SEPARATOR . $this->_componentName . DIRECTORY_SEPARATOR . Hpls_Consts0::FILE_CONFIG_COMPONENT;
		if (file_exists($filenameETC)) {
			$this->_configData = new Zend_Config_Ini($filenameETC, null, true);
		} elseif (file_exists($filename)) {
			$this->_configData = new Zend_Config_Ini($filename, null, true);
		} else {
			$this->_configData = new Zend_Config(array(), true);
		}
	
	}

	protected function readCompConfig($compname, $configDir) {
	}

}