<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 26, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Plugins/block.lc.php $
 *
 */
/**
 *
 */
require_once 'Hpls/I18n/Utils.php';


/**
 * Übersetzt den in $content string per Hpls_I18n_Utils::trans4Smarty
 * @param unknown_type $params
 * @param unknown_type $content
 * @param Smarty_Internal_Template $smarty
 * @param unknown_type $repeat
 * @return void|Ambigous <NULL, string, mixed>
 */
function smarty_block_lc($params, $content, Smarty_Internal_Template &$smarty, &$repeat) {
	if ($repeat) {
		return;
	}
	$escape = empty($params['_noescape']) ? false: ! $params['_noescape'];
	$nonl2br = empty($params['_nonl2br']) ? false : $params['_nonl2br'] == true;
	$trans = null;
	
	if (count($params) > 0) {
		$doFallback = !empty($params['_fallback']);
		//replace variables
		$trans = Hpls_I18n_Utils::translateReplace($content, $params, true);
		if ($doFallback === true) {
			if (strcasecmp($content, $trans) === 0) {
				$trans = $params['_fallback'];
			}
		}
	} else {
		$trans = Hpls_I18n_Utils::translate($content);
	}
	
	if ($escape) {
		$trans = htmlentities($trans);
	}
	// \n zu <br/> konvertieren?
	if (FALSE === $nonl2br) {
		$trans = str_replace('\n', '<br/>', $trans);
	}
	
	return $trans;
}