<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Apr 14, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Plugins/function.checkedImg.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 */
/***/
require_once 'Hpls/View/Consts.php';

/**
 * @todo implement error handle, variable subtition
 * @param array $params
 * @param Smarty $smarty
 */
function smarty_function_checkedImg(array $params, Smarty_Internal_Template &$smarty) {
	$allowed = array(
			'alt' => 1,
			'title' => 1,
			'width' => 1,
			'height' => 1,
			'style' => 1 );
	
	if (!isset($params['file'])) {
		throw new Hpls_Exception_Template("{checkedImg} needed attribute 'file' not set.");
	}
	$img = $params['file'];
	
	if (isset($params['urlPath'])) {
		$src = $params['urlPath'];
	} else {
		$src = Hpls_Application::i()->getThemeUrl();
	}
	
	//filesystem path
	$srvPath = '';
	if (isset($params['srvPath'])) {
		$srvPath = $params['srvPath'];
		$srvPath = str_ireplace('[[C:APPLIANCE_PART_PATH]]', APPLIANCE_PART_PATH, $srvPath);
	} else {
		$srvPath = Hpls_Application::i()->getThemeHtmlPath();
	}
	
	if (!file_exists($srvPath)) {
		require_once 'Hpls/Exception.php';
		throw new Hpls_Exception("'$srvPath' is not a valid path on server.");
	}
	
	if (file_exists("$srvPath/$img")) {
		$src = "$src/$img";
	} else {
		$src = "$src/" . $params['fallbackFile'];
	}
	
	//	$src = "$srvPath/$img";
	$ret = "<img src=\"$src\"";
	
	$remain = array_intersect_key($params, $allowed);
	
	foreach ($remain as $k => $v) {
		$ret .= " $k=\"$v\"";
	}
	if (DEBUG) {
		$ret .= " info=\"$srvPath/$img\"";
	}
	//	if (isset($params['title'])) {
	//		
	//	}
	//	if (isset($params['alt']))
	//	
	$ret .= '/>';
	//[[C:APPLIANCE_PART_PATH]]
	return $ret;
}