<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 25, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Plugins/function.headScripts.php $
 *
 */
/**
 *
 */
require_once 'Hpls/View/Consts.php';
require_once 'Zend/Debug.php';

/**
 * @todo comment
 *
 * @see smarty_block_headScript
 *
 * @param unknown_type $params
 * @param unknown_type $smarty
 * @return unknown_type
 */
function smarty_function_headScripts($params, Smarty_Internal_Template &$smarty) {
	$headVar = $smarty->getVariable(Hpls_View_Consts::HEAD_SCRIPTS, null, true, false)->value;
	$ret = '<!-- HeadScripts START -->';
	if (is_array($headVar)) {
		foreach ($headVar as $K => $V) {
			if (is_array($V) && count($V) > 0) {
				//				if (empty($V['src']) && (empty($V[Hpls_View_Consts::PARAM_CONTENT]) || trim($V[Hpls_View_Consts::PARAM_CONTENT]) == "")) {
				//					continue;
				//				}
				$ret .= "\n\t<script";
				foreach ($V as $paramName => $paramValue) {
					if ($paramName != Hpls_View_Consts::PARAM_CONTENT) {
						$ret .= " $paramName=\"$paramValue\"";
					}
				}
				if (isset($V[Hpls_View_Consts::PARAM_CONTENT]) && !empty($V[Hpls_View_Consts::PARAM_CONTENT])) {
					//
					$ret .= "><!--\n";
					$ret .= trim($V[Hpls_View_Consts::PARAM_CONTENT]);
					$ret .= "\n//-->\n</script>";
				} else { //close tag inline
					$ret .= '></script>';
				}
			} else {
				$ret .= "$V";
			}
		}
		$ret .= '<!-- HeadScripts END -->';
		return $ret;
	}
	
	return $ret;
}