<?php

/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 27.06.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/**
 */
require_once 'Hpls/Msgs.php';

/**
 *
 * @todo comment
 * @param $params unknown_type       	
 * @param $tplObj Smarty_Internal_Template       	
 * @return string
 */
function smarty_function_renderMsg($params, Smarty_Internal_Template &$tplObj) {
	$MSG = Hpls_Msgs::i(); // $smarty->getVariable(Hpls_View_Consts::V_MSGS)->value;
	$ret = '';
	$style = 'ul';
	$showCategory = false;
	if (!empty($params['style'])) {
		$style = (string) $params['style'];
	}
	if (!empty($params['showCategory'])) {
		$showCategory = (string) $params['showCategory'];
	}
	
	if (!empty($params['field'])) {
		// field msg
		if (Hpls_Msgs::i()->hasFieldMsg($params['field'])) {
			$tplData = new Smarty_Data($tplObj);
			$tplData->assign('messages', Hpls_Msgs::i()->getFieldMsgs($params['field']));
			$tplData->assign('showCategory', $showCategory);
			$tplData->assign('field', $params['field']);
			$ret .= $tplObj->fetch("_msgs/$style/field.tpl", null, null, $tplData);
			Hpls_Msgs::i()->incDisplayCountField($params['field']);
		}
	} elseif (!empty($params['group'])) {
		// sektion message
		if (Hpls_Msgs::i()->hasFieldMsg($params['group'])) {
			$tplData = new Smarty_Data($tplObj);
			$tplData->assign('messages', Hpls_Msgs::i()->getGroupMsgs($params['group']));
			$tplData->assign('showCategory', $showCategory);
			$tplData->assign('field', $params['group']);
			$ret .= $tplObj->fetch("_msgs/$style/group.tpl", null, null, $tplData);
			Hpls_Msgs::i()->incDisplayCountGroup($params['group']);
		}
	} elseif (Hpls_Msgs::i()->hasGlobalMsg()) {
		// globale message
		$tplData = new Smarty_Data($tplObj);
		$tplData->assign('messages', Hpls_Msgs::i()->getGlobalMsgs());
		$tplData->assign('showCategory', $showCategory);
		$ret .= $tplObj->fetch("_msgs/$style/global.tpl", null, null, $tplData);
		Hpls_Msgs::i()->incDisplayCountGlobal();
	}
	
	return $ret;
}