<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 28, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/Plugins/function.url.php $
 *
 */
/**
 *
 */
require_once 'Hpls/View/Consts.php';
require_once 'Hpls/Smarty/Smarty.php';

/**
 * @todo comment
 *
 * @param array $params
 * @param Hpls_Smarty_Smarty $smarty
 * @return unknown_type
 */
function smarty_function_url(array $params, Smarty_Internal_Template &$smarty) {
	if (count($params) <= 0) {
		$smarty->trigger_error("func.url: no params given.");
	}
	$ret = '';
	if (!empty($params[Hpls_View_Consts::PARAM_LINK])) {
		$ret = $params[Hpls_View_Consts::PARAM_LINK];
	} else {
		//link in form of module/controller/action
		$view = $smarty->smarty->getZendView();
		if (!empty($params['a'])) {
			$params['action'] = $params['a'];
			unset($params['a']);
		}
		if (!empty($params['m'])) {
			$params['module'] = $params['m'];
			unset($params['m']);
		}
		if (!empty($params['c'])) {
			$params['controller'] = $params['c'];
			unset($params['c']);
		}
		
		$ret = $view->url($params);
	}
	Hpls_Utils::log()->debug(__FUNCTION__ . ": url '$ret'");
	return $ret;
}