<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Jan 28, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2012-02-22 17:02:02 +0100 (Mi, 22 Feb 2012) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9235 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs.smarty/Hpls/Smarty/PluginsForm/block.form.php $
 *
 */
/**
 *
 */
require_once 'Hpls/View/Consts.php';
require_once 'Hpls/Utils.php';

//	public function assignOrClear(array $params,$varPrefix,$paramName,$scope = Smarty::SCOPE_GLOBAL) {
//		if (!empty($params[$paramName]))
//			$this->assign($varPrefix.ucfirst($paramName),$params[$paramName],false,$scope);
//		else
//			$this->clearAssign($varPrefix.ucfirst($paramName));
//	}


function smarty_block_form(array $params, $content, Smarty_Internal_Template &$smarty, $repeat) {
	if ($repeat) {
		//erster Aufruf, der keinen returnwert verlangt
		$smarty->assign('styleForm', isset($params['style']) ? $params['style'] : 'table');
		return;
	}
	
	$vars = new Smarty_Data(null, $smarty);
	
	if (isset($params['title'])) {
		$vars->assign('formTitle', $params['title']);
	}
	if (isset($params['id'])) {
		$vars->assign('formId', $params['id']);
	}
	if (isset($params['action'])) {
		$vars->assign('formAction', $params['action']);
	} else {
		$vars->assign('formAction', '');
	}
	if (isset($params['acceptcharset'])) {
		$vars->assign('formAcceptCharset', $params['acceptcharset']);
	}
	
	if (isset($params['enctype'])) {
		$vars->assign('formEncType', $params['enctype']);
	}
	
	$vars->assign('btnSubmitLabel', isset($params['submitLabel']) ? $params['submitLabel'] : 'btn_submit_label');
	$vars->assign('btnResetLabel', isset($params['resetLabel']) ? $params['resetLabel'] : 'btn_reset_label');
	$vars->assign('btnCancelLabel', isset($params['cancelLabel']) ? $params['cancelLabel'] : 'btn_cancel_label');
	
	$vars->assign('formMethod', isset($params['method']) ? $params['method'] : 'post');
	
	if (!empty($params['noSavebuttons'])) {
		$vars->assign('formNoSavebuttons', Hpls_Utils::toBool($params['noSavebuttons']));
	} else if (!empty($params['noResetbutton'])) {
	    $vars->assign('formNoResetbutton', Hpls_Utils::toBool($params['noResetbutton']));
	}
	
	$vars->assign('formContent', $content);
	
	$ret = $smarty->fetch('_form/form.tpl', null, null, $vars);
	
	return $ret;
}