<?php

/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 08.11.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
function smarty_block_formgroup(array $params, $content, Smarty_Internal_Template &$smarty, $repeat) {
	if ($repeat) {
		return;
	}
	$vars = new Smarty_Data(null, $smarty);
	$vars->assign('groupContent', $content);
	if (isset($params['title'])) {
		$title = $params['title'];
		if (empty($params['noI18N']) || $params['noI18N'] != FALSE) {
			$title = Hpls_I18n_Utils::translate($title);
		}
		if (!empty($params['allowHtml']) && $params['allowHtml'] != TRUE) {
			require_once 'Smarty/plugins/modifier_strip_tags.php';
			$title = smarty_modifier_strip_tags($title, FALSE);
		}
		$vars->assign('groupTitle', $title);
	}
	if (isset($params['id']))
		$vars->assign('group_id', $params['id']);
	if (!empty($params['description'])) {
		$vars->assign('group_description', $params['description']);
	}
	
	
	$style = empty($params['style']) ? 'table' : trim($params['style']);
	$vars->assign('style',$style);
	
	if (!empty($params['type']) && $params['type'] == 'fieldset') {
		return $smarty->fetch("_form/$style/fieldset.tpl", null, null, $vars);
	} else {
		return $smarty->fetch("_form/$style/group.tpl", null, null, $vars);
	}
}