<?php

/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 03.11.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
/**
 * Params:
 * <dl>
 * 	<dt>[style]</dt> <dd></dd>
 *  <dt>[type]</dt> <dd></dd>
 *  <dt>[name]</dt> <dd></dd>
 *  <dt>[id]</dt> <dd></dd>
 *  <dt>[label]</dt> <dd></dd>
 *  <dt>[cssClass]</dt> <dd></dd>
 *  <dt>[labelCssClass]</dt> <dd></dd>
 * </dl>
 * 
 * @param array $params
 * @param Smarty $smarty
 */
function smarty_function_formfield(array $params, Smarty_Internal_Template &$smarty) {
// 	Hpls_Debug::log()->debug(Hpls_Debug::print_r($smarty->getTemplateVars('styleForm'), __FUNCTION__));
	if ((empty($params['name']) && empty($params['id'])) || empty($params['type'])) {
		require_once 'Hpls/Exception/Template.php';
		throw new Hpls_Exception_Template("One of 'name' or 'type' is missing in the argument list.");
	}
	if (empty($params['style'])) {
		$params['style'] = $smarty->getTemplateVars('formStyle');
	}
	
	$name = empty($params['name']) ? $params['id'] : $params['name'];
	$type = $params['type'];
	$ret = null;
	
	switch ($params['style']) {
		case 'div' :
			$style = 'div';
			break;
		case 'table' :
		default :
			$style = 'table';
			break;
	}
	
	switch ($type) {
		case 'text' :
		case 'input':
		case 'file':
		case 'password':
			require_once 'Hpls/View/Smarty/Form/Element/Text.php';
			$renderer = new Hpls_View_Smarty_Form_Element_Text($params, $smarty);
			
			$ret = $renderer->render();
			break;
		case 'textarea' :
			require_once 'Hpls/View/Smarty/Form/Element/Textarea.php';
			$renderer = new Hpls_View_Smarty_Form_Element_Textarea($params, $smarty);
			
			$ret = $renderer->render();
			break;
		case 'yesno' :
			if (!isset($params['yes'])) {
				$params['yes'] = 'option_yes';
			}
			if (!isset($params['no'])) {
				$params['no'] = 'option_no';
			}
			if (!isset($params['layout'])) {
				$params['layout'] = 'h';
			}
			$params['options'] = array(
					'yes' => $params['yes'],
					'no' => $params['no'] );
			if (is_bool($params['value'])) {
				$params['value'] = $params['value']?'yes':'no';
			}
			$params['type'] = 'radio';
		//'break' ist absichtlich nicht hier, weil jetzt bei 'radio' weitergehen soll
		case 'radio' :
		case 'radiobox' :
			require_once 'Hpls/View/Smarty/Form/Element/Radio.php';
			$renderer = new Hpls_View_Smarty_Form_Element_Radio($params, $smarty);
			
			$ret = $renderer->render();
			break;
		case 'select' :
			require_once 'Hpls/View/Smarty/Form/Element/Select.php';
			$renderer = new Hpls_View_Smarty_Form_Element_Select($params, $smarty);
			
			$ret = $renderer->render();
			break;
		case 'check' :
		case 'checkbox' :
			require_once 'Hpls/View/Smarty/Form/Element/Checkbox.php';
			$renderer = new Hpls_View_Smarty_Form_Element_Checkbox($params, $smarty);
			$ret = $renderer->render();
			break;
		case 'submit':
		case 'reset':
		case 'button':
			require_once 'Hpls/View/Smarty/Form/Element/Button.php';
			$renderer = new Hpls_View_Smarty_Form_Element_Button($params, $smarty);
			$ret = $renderer->render();
			break;
		default :
			$ret = '<p style="color: red">Style: ' . htmlspecialchars($type . ' not implemented yet in ' . __FUNCTION__ . ' in ' . __FILE__) . '</p>';
			break;
	}
	return $ret;
}