<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 28.11.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Consts0.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package ??
 * @subpackage ??
 * @version $LastChangedRevision$
 * @since 1.0.9
 * @deprecated Es ist nur ein Platzhalter aus dem Branch für HMT2. wenn der gemerged wird, sollte diese datei überschrieben werden.
 */
class Hpls_User_Object {
	protected $_roles = array();
	protected $_roleMain = Hpls_Consts0::ROLE_ADMIN;
	protected $_name = null;
	protected $_masqueradeAs = null;
	/**
	 * Source which identified the user. Name from 'auth.ini'
	 * @var String
	 */
	protected $_authedBy = null;
	protected $_ownEmails = array();
	protected $_ownDomains = array();
	protected $_ownAccounts = array();

	public function addRole($role) {
		$this->_roles[$role] = $role;
	}

	public function removeRole($role) {
		if (isset($this->_roles[$role])) {
			unset($this->_roles[$role]);
		}
	}

	/**
	 * @return the $_roles
	 */
	public function getRoles() {
		return $this->_roles;
	}

	/**
	 * @return the $_name
	 */
	public function getName() {
		return $this->_name;
	}

	/**
	 * @param field_type $_name
	 */
	public function setName($_name) {
		$this->_name = $_name;
	}

	/**
	 * @param array $_roles
	 */
	public function setRoles($_roles) {
		$this->_roles = $_roles;
	}

	public function setMainRole($role) {
		$this->_roleMain = $role;
	}

	public function getMainRole() {
		return $this->_roleMain;
	}

	public function setMasqueradeAs($asUsername) {
		$this->_masqueradeAs = $asUsername;
	}

	public function getMasqueradeAs() {
		return $this->_masqueradeAs;
	}

	public function addEmail($emails) {
		if (is_null($this->_ownEmails)) {
			$this->_ownEmails = array();
		}
		if (!is_array($emails)) {
			$emails = array(
					$emails );
		}
		foreach ($emails as $email) {
			$email = trim($email);
			if (!empty($email)) {
				$this->_ownEmails[strtolower($email)] = $email;
			}
		}
	}

	public function removeEmail($email) {
		$email = strtolower(trim($email));
		if (!empty($this->_ownEmails) && isset($this->_ownEmails[$email])) {
			unset($this->_ownEmails[$email]);
		}
	}

	public function getEmails() {
		return $this->_ownEmails;
	}

	public function addDomain($domain) {
		if (is_null($this->_ownDomains)) {
			$this->_ownDomains = array();
		}
		$domain = trim($domain);
		$this->_ownDomains[strtolower($domain)] = $domain;
	}

	public function removeDomain($domain) {
		$domain = strtolower(trim($domain));
		if (!empty($this->_ownDomains) && isset($this->_ownDomains[$domain])) {
			unset($this->_ownDomains[$domain]);
		}
	}

	public function getDomains() {
		return $this->_ownDomains;
	}

	public function addAccount($account) {
		if (is_null($this->_ownAccounts)) {
			$this->_ownAccounts = array();
		}
		$account = trim($account);
		$this->_ownAccounts[strtolower($account)] = $account;
	}

	public function removeAccount($account) {
		$account = strtolower(trim($account));
		if (!empty($this->_ownAccounts) && isset($this->_ownAccounts[$account])) {
			unset($this->_ownAccounts[$account]);
		}
	}

	public function getAccounts() {
		return $this->_ownAccounts;
	}

	/**
	 * @return the $_authedBy
	 */
	public function getAuthedBy() {
		return $this->_authedBy;
	}

	/**
	 * Der AuthSource, der in auth.xml[/auth/$_authedBy] spezifiert wurde und mit dem der Login geklappt hat.
	 * @param String $_authedBy
	 */
	public function setAuthedBy($_authedBy) {
		$this->_authedBy = $_authedBy;
	}

}