<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 15.04.2011
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
class Hpls_Utils_Time {

	static public function isoToTimestamp($isodate) {
		//'YYYY-MM-DD HH:MM:SS.mm'
		return strtotime($isodate);
	}

	static public function timediffToSeconds2($str) {
		
		$d = array(
				'd' => 86400,
				'm' => 60,
				'h' => 3600,
				's' => 1,
				'w' => 604800,
				'y' => 31536000 );
		$str = strtolower($str);
		$len = strlen($str);
		$number = '';
		$seconds = 0;
		for ($i = 0; $i < $len; $i++) {
			if (isset($d[$str[$i]])) {
				$seconds += (int) $number * $d[$str[$i]];
				$number = '';
			} elseif ($str[$i] === ' ') {
				$number = '';
			} else {
				$number .= $str[$i];
			}
		}
		return $seconds;
	}

	static public function timediffToSeconds($timeStr) {
		$timeStr = str_replace(' ', '', trim($timeStr));
		$matches = array();
		$ret = 0;
		if (preg_match('/^(\d+[smhdwy]+)+$/i', $timeStr) > 0) {
			$ret2 = preg_replace(array(
					'/s/',
					'/m/',
					'/h/',
					'/d/',
					'/w/',
					//					'/M/',
					'/y/' ), array(
					'+',
					'*60+',
					'*3600+',
					'*86400+',
					'*604800+',
					//					'*30*7*24*3600+',
					'*31536000+' ), $timeStr) . '0';
			$ret2 = "\$ret = $ret2;";
			//			Hpls_Debug::log()->debug(7Hpls_Debug::print_r($ret2, __METHOD__));
			eval($ret2);
		} else {
			//Fehler: kein TimeDiff-Format
			return null;
		}
		return $ret;
	}
}