<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created   : Mar 30, 2010
 * created by: Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate: 2011-12-28 17:05:55 +0100 (Mi, 28 Dez 2011) $
 * last changed by: $LastChangedBy: cgr $
 * revision       : $LastChangedRevision: 9196 $
 * SVN head URL   : $HeadURL: https://buero-svn.jpberlin.de/Dev-Repository/AC/GUI/Core/trunk/hpls.ac.core2.gui.libs/Hpls/View/Paginator/Interface.php $
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 */
/***/

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package HPLS
 * @subpackage View
 * @version $LastChangedRevision: 9196 $
 * @since beta
 *
 */
interface Hpls_View_Paginator_Interface {
	const URL_PH_PAGE = '[[PAGE]]';
	const PAGING_RANGE = 'pagingRange';
	const PAGING_LAST = 'pagingLast';
	const PAGING_FIRST = 'pagingFirst';
	const PAGE_CURRENT = 'pageCurrent';
	const PAGE_LAST = 'pageLast';
	const PAGE_FIRST = 'pageFirst';
	const PAGE_NEXT = 'pageNext';
	const PAGE_PREV = 'pagePrev';
	const ITEM_LIMIT = 'itemLimit';
	const ITEM_FIRST = 'itemFirst';
	const ITEM_LAST = 'itemLast';
	const ITEM_COUNT = 'itemCount';
	const PAGE_LINK_BASE = 'pageLinkBase';

	public function needsScrolling();

	public function setPageCurrent($pageNum);

	public function setItemLimit($value);

	public function setPagingRange($value);

	public function setItemCount($value);

	public function isFirstContinous();

	public function isLastContinous();

	public function isCurrentPage($pageNum);

	public function getLink($pageNum);

	public function setPageLinkBase($url);

	/**
	 * @return array 
	 */
	public function getPagesInRange();
}