<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 03.11.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/View/Smarty/Form/ElementAbstract.php';

/**
 * @todo comment
 *
 * @author Christoph Graupner <c.graupner@heinlein-support.de>
 * @copyright Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * @package AC2
 * @subpackage View
 * @version $LastChangedRevision$
 * @since 1.0.6
 */
class Hpls_View_Smarty_Form_Element_Radio extends Hpls_View_Smarty_Form_ElementAbstract {

	/* (non-PHPdoc)
	 * @see Hpls_View_Smarty_Form_ElementAbstract::prepareRenderData()
	 */
	public function prepareRenderData(Smarty_Data $smartyData) {
		$this->log()->debug(__METHOD__);
		// TODO Auto-generated method stub
		$this->prepareValue($smartyData);
		$smartyData->assign('labelText', $this->getParam('label', $this->getName()) . '_label');
		$smartyData->assign('fieldOptions', $this->prepareOptions());
		
		$smartyData->assign('fieldName', $this->getName());
		$smartyData->assign('labelName', $this->getName() . '-label');
		if ($this->hasParam('cssClass')) {
			$smartyData->assign('fieldCssClass', $this->getParam('cssClass'));
		}
		if ($this->hasParam('labelCssClass')) {
			$smartyData->assign('labelCssClass', $this->getParam('labelCssClass'));
		}
		$smartyData->assign('layout', $this->getParam('layout', 'vertical'));
		return $smartyData;
	
	}

	protected function prepareOptions() {
		$this->log()->debug(Hpls_Debug::print_r($this->getParams(), __METHOD__));
		$value = $this->getParam('value', null);
		$options = $this->getParam('options');
		if (is_null($options) || empty($options)) {
			require_once 'Hpls/Exception/Template.php';
			throw new Hpls_Exception_Template("Param 'options' is missing or empty.");
		}
		if (!is_array($options)) {
			$options = explode(',', $options);
		}
		if (is_array($value)) {
			$value = $value['value'];
		}		
		
		$ret = array();
		foreach ($options as $key => $option) {
			if (!is_array($option)) {
				$option2 = explode('=>', $option);
				if (count($option2) == 2) {
					$key = $option2[0];
					$option = $option2[1];
				}
			}
			$ret[] = array(
					'value' => $key,
					'label' => $option,
					'selected' => ($key == $value) );
		}
		//den ersten Eintrag selektieren, wenn nicht angegeben und selektion nicht verboten
		if (is_null($value) && !$this->getParam('noSelection', false) && count($ret) > 0) {
			$ret[0]['selected'] = true;
		}
		$this->log()->debug(Hpls_Debug::print_r($ret, __METHOD__));
		return $ret;
	}

	protected function prepareValue(Smarty_Data $smartyData) {
		$value = $this->getParam('value', null);
		if (is_null($value)) {
			return;
		} elseif (is_array($value)) {
			if (isset($value['error'])) {
				$this->prepareError($value, $smartyData);
			}
		} else {
			$value = array(
					'value' => $value );
		}
		$smartyData->assign('fieldValue', $value);
	}

	protected function prepareError(array $value, Smarty_Data $smartyData) {
		$error = $value['error'];
		if (!is_array($error)) {
			$error = array(
					$error );
		}
		$smartyData->assign('fieldErrors', $error);
	}

}