<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 *
 * created        : 08.11.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/View/Smarty/Form/ElementAbstract.php';

class Hpls_View_Smarty_Form_Element_Text extends Hpls_View_Smarty_Form_ElementAbstract {

	/* (non-PHPdoc)
	 * @see Hpls_View_Smarty_Form_ElementAbstract::prepareRenderData()
	 */
	public function prepareRenderData(Smarty_Data $smartyData) {
		// TODO Auto-generated method stub
		$smartyData->assign('labelText', $this->getParam('label', $this->getName()) . '_label');
		$smartyData->assign('fieldValue', $this->getParam('value'));
		$smartyData->assign('fieldName', $this->getName());
		$smartyData->assign('labelName', $this->getName() . '-label');
		if ($this->hasParam('cssClass')) {
			$smartyData->assign('fieldCssClass', $this->getParam('cssClass'));
		}
		if ($this->hasParam('labelCssClass')) {
			$smartyData->assign('labelCssClass', $this->getParam('labelCssClass'));
		}
		switch ($this->getParam('type', '')) {
			case 'password' :
				$smartyData->assign('inputType', 'password');
				break;
			case 'file':
				$smartyData->assign('inputType', 'file');
				break;
			case 'text':
			default:
			$smartyData->assign('inputType', 'text');
		}
		return $smartyData;
	}

	
	public function getType() {
		return 'text';
	}
}