<?php
/**
 * Copyright (c) Heinlein Professional Linux Support GmbH
 * 
 * created        : 03.11.2010
 * created by     : Christoph Graupner <c.graupner@heinlein-support.de>
 *
 * last changed   : $LastChangedDate$
 * last changed by: $LastChangedBy$
 * revision       : $LastChangedRevision$
 * SVN head URL   : $HeadURL$
 * 
 * author         : Christoph Graupner <c.graupner@heinlein-support.de>
 */
/***/
require_once 'Hpls/Utils/Logusing.php';

abstract class Hpls_View_Smarty_Form_ElementAbstract extends Hpls_Utils_Logusing {
	
	protected $_params;
	protected $_smarty;
	protected $_smartyData;

	public function __construct(array $params, Smarty_Internal_Template &$smarty) {
		if (empty($params['style'])) {
			$params['style'] = 'table';
		}
		if (!isset($params['name']) && isset($params['id'])) {
			$params['name'] = $params['id'];
		}
		$this->_params = $params;
		$this->_smarty = $smarty;
	}

	/**
	 * Enter description here ...
	 * @param Smarty_Data $smartyData
	 * @return Smarty_Data
	 */
	abstract public function prepareRenderData(Smarty_Data $smartyData);

	public function render() {
		return $this->getSmarty()->fetch($this->getTemplate(), null, null, $this->prepareRenderData($this->getSmartyData()));
	}

	protected function getSmarty() {
		return $this->_smarty;
	}

	protected function getParams() {
		return $this->_params;
	}

	protected function getTemplate() {
		$style = $this->getStyle();
		$type = $this->getType();
		return "_form/$style/element/$type.tpl";
	}

	protected function getStyle() {
		return $this->_params['style'];
	}

	protected function getType() {
		return $this->_params['type'];
	}

	protected function getName() {
		return $this->_params['name'];
	}

	protected function getSmartyData() {
		if (is_null($this->_smartyData)) {
			$this->_smartyData = new Smarty_Data(null, $this->getSmarty());
		}
		return $this->_smartyData;
	}

	protected function hasParam($key) {
		return isset($this->_params[$key]);
	}

	protected function getParam($key, $default = null) {
		return isset($this->_params[$key]) ? $this->_params[$key] : $default;
	}
}