--
-- Copyright (c) Heinlein Professional Linux Support GmbH
--
-- created   : 06.09.2010
-- created by: Christoph Graupner <c.graupner@heinlein-support.de>
--
-- last changed   : $LastChangedDate: 2012-02-22 14:57:33 +0100 (Mi, 22. Feb 2012) $
-- last changed by: $LastChangedBy: cgr $
-- revision       : $LastChangedRevision: 9229 $
-- 
-- author         : Christoph Graupner <c.graupner@heinlein-support.de>
--

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

--
-- Name: config; Type: TABLE; Schema: public; Owner: mailtrace; Tablespace: 
--
-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TABLE [[TABLEPREFIX]]config (
    key character varying(1024) NOT NULL,
    value text,
    time_created timestamp with time zone DEFAULT now() NOT NULL,
    time_updated timestamp with time zone DEFAULT now() NOT NULL,
    CONSTRAINT pri_config_key PRIMARY KEY (key)
);
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

--
-- Name: regexrule; Type: TABLE; Schema: public; Owner: mailtrace; Tablespace: 
--

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TABLE [[TABLEPREFIX]]regexrule (
    id integer NOT NULL,
    id_t character varying(1) DEFAULT '[[DBKEYNAME]]'::character varying NOT NULL,
    regex character varying(1024) NOT NULL,
    rule_id integer,
    deactivated boolean,
    description text,
    param_map character varying(512),
    priority integer DEFAULT 0 NOT NULL,
    time_created timestamp with time zone DEFAULT now() NOT NULL,
    time_updated timestamp with time zone DEFAULT now() NOT NULL,
    rule_id_t character varying(1) DEFAULT '[[DBKEYNAME]]'::character varying NOT NULL,
    inactive_state smallint DEFAULT 0 NOT NULL
);
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!


--
-- Name: regexrule_id_seq; Type: SEQUENCE; Schema: public; Owner: mailtrace
--
-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE SEQUENCE [[TABLEPREFIX]]regexrule_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

--
-- Name: regexrule_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: mailtrace
--

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
ALTER SEQUENCE [[TABLEPREFIX]]regexrule_id_seq OWNED BY [[TABLEPREFIX]]regexrule.id;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

--
-- Name: roles; Type: TABLE; Schema: public; Owner: mailtrace; Tablespace: 
--

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TABLE [[TABLEPREFIX]]roles (
    id integer NOT NULL,
    id_t character varying(1) DEFAULT '[[DBKEYNAME]]'::character varying NOT NULL,
    role_name character varying(50) NOT NULL,
    time_created timestamp with time zone DEFAULT now() NOT NULL,
    time_updated timestamp with time zone DEFAULT now() NOT NULL,
    inactive_state smallint DEFAULT 0 NOT NULL
);
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

--
-- Name: roles_id_seq; Type: SEQUENCE; Schema: public; Owner: mailtrace
--
-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE SEQUENCE [[TABLEPREFIX]]roles_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

--
-- Name: roles_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: mailtrace
--

    -- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
ALTER SEQUENCE [[TABLEPREFIX]]roles_id_seq OWNED BY [[TABLEPREFIX]]roles.id;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

--
-- Name: rule_ids; Type: TABLE; Schema: public; Owner: mailtrace; Tablespace: 
--

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE TABLE [[TABLEPREFIX]]rule_ids (
    id integer NOT NULL,
    id_t character varying(1) DEFAULT '[[DBKEYNAME]]'::character varying NOT NULL,
    rule_name character varying(50) NOT NULL,
    description text,
    time_created timestamp with time zone DEFAULT now() NOT NULL,
    time_updated timestamp with time zone DEFAULT now() NOT NULL,
    inactive_state smallint DEFAULT 0 NOT NULL
);
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

--
-- Name: rule_ids_id_seq; Type: SEQUENCE; Schema: public; Owner: mailtrace
--

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
CREATE SEQUENCE [[TABLEPREFIX]]rule_ids_id_seq
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!

--
-- Name: rule_ids_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: mailtrace
--

-- PHPSQL-BEGIN <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!
ALTER SEQUENCE [[TABLEPREFIX]]rule_ids_id_seq OWNED BY [[TABLEPREFIX]]rule_ids.id;
-- PHPSQL-END <-- DO NOT REMOVE and LEAVE THIS COMMENT AS IS!


